﻿DROP FUNCTION IF EXISTS dbo.fnGetDokumentumGondviselok;  
GO

CREATE FUNCTION fnGetDokumentumGondviselok (@osztalyCsoportId INT, @tanevId INT, @isCsokkentettGondviselo NVARCHAR(1), @isTorvenyesGondviselo NVARCHAR(1) = NULL)
RETURNS @Result TABLE (  
   GondviseloId    INT NOT NULL  
  ,GondviseloNev  NVARCHAR(MAX) NOT NULL  
  ,TanuloId      INT NOT NULL
  ,RokonsagifokId  INT
) AS  
BEGIN
INSERT INTO @Result (GondviseloId, GondviseloNev, TanuloId, RokonsagifokId)
SELECT DISTINCT 
   Gondviselo.ID        GondviseloId
  ,Gondviselo.C_NEV      GondviseloNev
  ,Gondviselo.C_TANULOID    TanuloId
  ,Gondviselo.C_ROKONSAGFOKA  RokonsagifokId
FROM T_GONDVISELO_OSSZES Gondviselo
  INNER JOIN fnGetDokumentumOsztalyokCsoportokTanuloi(@tanevId, @osztalyCsoportId, 'T') OsztalyTanuloi ON OsztalyTanuloi.TanuloId = Gondviselo.C_TANULOID
WHERE
  Gondviselo.TOROLT = 'F'
  AND (@isTorvenyesGondviselo IS NULL OR Gondviselo.C_ISTORVENYESKEPVISELO = @isTorvenyesGondviselo)  
  AND (Gondviselo.C_ISCSOKKENTETTGONDVISELO IS NULL OR Gondviselo.C_ISCSOKKENTETTGONDVISELO = @isCsokkentettGondviselo)
  AND Gondviselo.C_TANEVID = @tanevId
  
RETURN
END
GO