﻿DROP FUNCTION IF EXISTS dbo.fnOsztondijHistoryOszlopok
GO

CREATE FUNCTION dbo.fnOsztondijHistoryOszlopok()
RETURNS TABLE
AS
RETURN (
SELECT TablaId, TablaNev, OszlopNev, OszlopTipus, Alias
FROM (
VALUES
-- TablaId      TablaNev                 OszlopNev                         OszlopTipus             Alias                                     
  (1,         'T_OSZTALYCSOPORT',      'C_EVFOLYAMTIPUSA',               'EvfolyamTipus',        N'Az osztály évfolyama'                  ),
  (1,         'T_OSZTALYCSOPORT',      'C_ISTECHNIKAI',                  'Boolean',              N'Az osztály technikai'                  ),
  (1,         'T_OSZTALYCSOPORT',      'C_KERESZTFELEVES',               'Boolean',              N'Az osztály keresztféléves'             ),
  (1,         'T_OSZTALYCSOPORT',      'C_FELADATKATEGORIAID',           'OktNevelesiKategoria', N'Az osztály modulja'                    ),
  (1,         'T_OSZTALYCSOPORT',      'C_VEGZOSEVFOLYAM',               'Boolean',              N'Az osztály végzős'                     ),
  (1,         'T_OSZTALYCSOPORT',      'TOROLT',                         'Boolean',              N'Az osztály törölt'                     ),
  (2,         'T_TANULO',              'C_EVISMETLO',                    'Boolean',              N'A tanuló évismétlő'                    ),
  (2,         'T_TANULO',              'C_ISBESZAMITASOS',               'Boolean',              N'A tanuló beszámításos'                 ),
  (2,         'T_TANULO',              'C_ISMASODIKTOBBSZAKMA',          'Boolean',              N'A tanuló nem első szakmás'             ),
  (2,         'T_TANULO',              'C_ISOSZTONDIJBOLKIZARVA',        'Boolean',              N'A tanuló az ösztöndíjból kizárt'       ),
  (2,         'T_TANULO',              'C_ISSZAKKEPZESIMUNKASZERZODESS', 'Boolean',              N'A tanuló munkaszerződéses'             ),
  (2,         'T_TANULO',              'C_JOGVISZONYATSZUNETELTETO',     'Boolean',              N'A tanuló jogviszonya szünetel'         ),
  (2,         'T_TANULO',              'C_JOGVISZONYTIPUSID',            'JogviszonyTipus',      N'A tanuló jogviszonya'                  ),
  (2,         'T_TANULO',              'C_KEZIATLAG',                    'NULL',                 N'A tanuló beállított átlaga'            ),
  (2,         'T_TANULO',              'C_SZAMITOTTATLAG',               'NULL',                 N'A tanuló számított átlaga'             ),
  (2,         'T_TANULO',              'C_TANULOSZERZODESES',            'NULL',                 N'A tanuló tanulószerződéses'            ),
  (2,         'T_TANULO',              'C_VENDEG',                       'Boolean',              N'A tanuló vendégtanuló'                 ),
  (2,         'T_TANULO',              'C_ISBESZAMITASOSFIXSZAZALEK',    'Boolean',              N'A tanulónak nincs releváns átlaga'     ),
  (2,         'T_TANULO',              'C_ISMULASZTASMIATTKIZART',       'Boolean',              N'A tanuló a hiányzásai miatt kizárt'    ),
  (2,         'T_TANULO',              'C_ISSIKERESAGAZATIVIZSGA',       'Boolean',              N'A tanuló sikeres ágazati vizsgát tett' ),
  (2,         'T_TANULO',              'C_ISATLAGSZAKKEPZESI',           'Boolean',              N'Átlag szakképzési'                     ),
  (2,         'T_TANULO',              'C_ISINGYENESKEPZES',             'Boolean',              N'A tanuló ingyenes képzésben vesz részt'),
  (2,         'T_TANULO',              'TOROLT',                         'Boolean',              N'A tanuló törölt'                       ),
  (3,         'T_TANULOCSOPORT',       'C_BELEPESDATUM',                 'DateTime',             N'A tanuló besorolásának dátuma'         ),
  (3,         'T_TANULOCSOPORT',       'C_KILEPESDATUM',                 'DateTime',             N'A tanuló kisorolásának dátuma'         ),
  (3,         'T_TANULOCSOPORT',       'C_JOGVISZONYTIPUSID',            'JogviszonyTipus',      N'A tanuló jogviszonya'                  ),
  (3,         'T_TANULOCSOPORT',       'TOROLT',                         'Boolean',              N'A tanuló besorolása törölt'            ),
  (4,         'T_TANULOMULASZTAS',     'C_IGAZOLT',                      'Boolean',              N'A tanuló mulasztása igazolt'           ),
  (4,         'T_TANULOMULASZTAS',     'C_TIPUS',                        'MulasztasTipus',       N'A tanuló mulasztásának típusa'         ),
  (4,         'T_TANULOMULASZTAS',     'C_TANITASIORAKID',               'NULL',                 N'A tanuló mulasztásának tanórája'       ),
  (4,         'T_TANULOMULASZTAS',     'C_ORATANULOIID',                 'NULL',                 N'A tanuló mulasztásának tanulója'       ),
  (4,         'T_TANULOMULASZTAS',     'TOROLT',                         'Boolean',              N'A tanuló mulasztása törölt'            ),
  (5,         'T_TANULOTANUGYIADATOK', 'C_EVISMETLO',                    'Boolean',              N'A tanuló évismétlő'                    ),
  (5,         'T_TANULOTANUGYIADATOK', 'C_ISBESZAMITASOS',               'Boolean',              N'A tanuló beszámításos'                 ),
  (5,         'T_TANULOTANUGYIADATOK', 'C_ISMASODIKTOBBSZAKMA',          'Boolean',              N'A tanuló nem első szakmás'             ),
  (5,         'T_TANULOTANUGYIADATOK', 'C_ISSZAKKEPZESIMUNKASZERZODESS', 'Boolean',              N'A tanuló munkaszerződéses'             ),
  (5,         'T_TANULOTANUGYIADATOK', 'C_JOGVISZONYATSZUNETELTETO',     'Boolean',              N'A tanuló jogviszonya szünetel'         ),
  (5,         'T_TANULOTANUGYIADATOK', 'C_TANULOEVFOLYAMTIPUSID',        'Boolean',              N'A tanuló egyéni évfolyama'             ),
  (5,         'T_TANULOTANUGYIADATOK', 'C_TANULOSZERZODESES',            'Boolean',              N'A tanuló tanulószerződéses'            ),
  (5,         'T_TANULOTANUGYIADATOK', 'C_VENDEG',                       'Boolean',              N'A tanuló vendégtanuló'                 ),
  (5,         'T_TANULOTANUGYIADATOK', 'TOROLT',                         'Boolean',              N'A tanuló vagy besorolása törölt'       ),
  (5,         'T_TANULOTANUGYIADATOK', 'C_ISBESZAMITASOSFIXSZAZALEK',    'Boolean',              N'A tanulónak nincs releváns átlaga'     ),
  (5,         'T_TANULOTANUGYIADATOK', 'C_AGAZATUJSZKTTIPUSID',          'AgazatUjSzktTipus',    N'A tanuló képzésének ágazata'           ),
  (5,         'T_TANULOTANUGYIADATOK', 'C_SZAKMATIPUSID',                'SzakmaTipus',          N'A tanuló képzésének szakmatípusa'      )
) as t(TablaId, TablaNev, OszlopNev, OszlopTipus, Alias)
)
GO