﻿-- =============================================
-- Description:  <Ellenőrizzuk, hogy a felhasználóhoz tartozik-e a paraméterben megadott szerepkor>
-- =============================================
DROP PROCEDURE IF EXISTS [dbo].[sp_CheckFelhasznaloHasSzerepkor]
GO

CREATE PROCEDURE [dbo].[sp_CheckFelhasznaloHasSzerepkor]
  @pFelhasznaloId AS INT,
  @pSzerepkorTipusId AS INT
AS
BEGIN
  SET NOCOUNT ON;
  
  IF EXISTS(
    SELECT 1
    FROM 
      T_FELHASZNALO felhasznalo
    LEFT JOIN
      T_FELHASZNALO_SZEREPKOR felhasznaloSzerepkor ON
        felhasznaloSzerepkor.C_FELHASZNALOID = felhasznalo.ID
    LEFT JOIN
      T_SZEREPKOR szerepkor ON
        szerepkor.ID = felhasznaloSzerepkor.C_SZEREPKORID
    WHERE 
      felhasznalo.TOROLT = 'F' AND
      felhasznalo.ID = @pFelhasznaloId AND
      szerepkor.TOROLT = 'F' AND
      szerepkor.C_SZEREPKORTIPUS = @pSzerepkorTipusId
  )
        SELECT 1
    ELSE
        SELECT 0
      
END
GO
