DROP PROCEDURE IF EXISTS dbo.sp_ExportEsl_A03T01_1
GO

CREATE PROCEDURE [dbo].[sp_ExportEsl_A03T01_1]
   @tanevId int
  ,@feladatEllatasiHelyId int
  ,@isFelevi int = 0
  ,@osztalyzatTipusTypeID int = 44
AS
BEGIN
  SET NOCOUNT ON;  
  --Táblák deklarálása
  CREATE TABLE #Tanulok (
     TanuloNev nvarchar(1024)
    ,Neme int
    ,Evfolyam int
    ,Kategoria nvarchar(500)
  )
  CREATE TABLE #TanulokOsszes (
     Kategoria nvarchar(500)
    ,Osszes int
    ,OsszesLany int
  )
  CREATE TABLE #TanuloErtekeles (
     Id int
    ,Tanulo int
    ,Ertekeles int
    ,Tipus int
  )
  CREATE TABLE #ErintettTanulok (
     Evfolyam int
    ,TanuloId int
    ,Neme int
    ,TanuloNev nvarchar(255)
    ,Oktatasiazonosito nvarchar(11)
    ,TanuloOsztalyNev nvarchar(255)
    ,IsKozepesMiatt int
    ,IsRontasMiatt int
    ,TanuloOsztalyId int
    ,INDEX IX_01 (TanuloId)
  )
  CREATE TABLE #KetFeltetelTanulok (
     TanuloId int
    ,Evfolyam int
    ,Neme int
    ,TanuloNev nvarchar(510)
    ,OktatasiAzonosito nvarchar(11)
    ,TanuloOsztalyNev nvarchar(255)
    ,IsHianyzasMiatt int
    ,IsKiemeltMiatt int
    ,IsGyermekVedelemMiatt int
    ,IsAltalanosIskolaMiatt int
  )
  CREATE TABLE #Kategoria(
     KategoriaNev nvarchar(500)
    ,Sorrend int
  )
  CREATE TABLE #IntezmenyEvfolyamok(
     ID int
    ,EvfolyamNev nvarchar(510)
  )
  INSERT INTO #Kategoria( --Egyszerűbb így, hogy meglegyen minden kategória a végén, sorrenddel együtt, akkor is, ha nincs hozzá elem
     KategoriaNev
    ,Sorrend
  ) VALUES
   ('Osszesen',1)
  ,('Lany',2)
  ,('AFelevErtekelesenelMinositesenelATanuloEgyTizedesjegyigSzamitottTanulmanyiAtlagaAMagatartasEsSzorgalomErtekelesetMinositesetNemBeleszamitvaNemEriElKozepes3Szintet',3)
  ,('AzEvVegiJegyekAlapjanAFeleviJegyekhezKepestLegalabb11NyiAtlagotRontoTanulokSzama',4)
  ,('AFelevErtekelesenelMinositesenelATanuloEgyVagyTobbTantargybolElegtelen1OsztalyzatotKapott',5)
  ,('AFelevMagatartasanakErtekelesenelMinositesenelATanuloRossz2ErtekelestKapott',6)
  ,('AFelevSzorgalmanakErtekelesenelMinositesenelATanuloHanyag2ErtekelestKapott',7)
  ,('AzAdottTanitasiEvbenEvismetlesreKotelezett',8)
  ,('AFelevbenATanulo50OratMeghaladoHianyzassalRendelkezik',9)
  ,('AFelevbenSzuloiKeresreMagantanulovaValtTanulo',10)
  ,('AFelevbenMenekultOltalmazottMenedekesTanulokSzama',11)
  ,('AFelevbenVeszelyezeztetteValtTanulokSzama',12)
  ,('AFelevbenIdeiglenesHatallyalElhelyezettVagyNevelesbeVettTanulokSzama',13)
  ,('KettoFeltetelTelejesuleseEsetenLemorzsolodassalVeszelyeztetettTanulo',14)
  ,('EbbolAFelevben100OratEleroIgazoltHianyzassalRendelkezoTanulokSzama',15)
  ,('EbbolKiemeltFigyelmetIgenyloTanulokSzamaAKiemeltenTehetsegesTanulokKivetelevel',16)
  ,('EbbolRendszeresGyermekvedelmiKedvezmenybenReszesuloTanulokSzama',17)
  ,('EbbolAlapfokuOktatasbanBetoltotteA16Eletevet',18)

  DECLARE @FelevKezdete DATETIME= (
    SELECT C_DATUM + IIF(@isFelevi = 1, 0, 1)
    FROM T_TANEVRENDJE_OSSZES tr
    WHERE C_NAPTIPUSA = IIF(@isFelevi = 1, 1394, 1400)
      AND C_TANEVID = @tanevid
      AND TOROLT = 'F'
    )
  
  DECLARE @FelevVege DATETIME= (
    SELECT C_DATUM + 1
    FROM T_TANEVRENDJE tr
    WHERE C_NAPTIPUSA = IIF(@isFelevi = 1, 1400, 1395)
      AND C_TANEVID=@tanevid
      AND TOROLT='F')
  
  DECLARE @ertekelesTipus int=IIF(@isFelevi=1,1519,1520) 
  DECLARE @osszesDb int               
  DECLARE @cols nvarchar(max)
  INSERT INTO #IntezmenyEvfolyamok(
     Id
    ,Evfolyamnev
  ) 
  SELECT DISTINCT 
     dib.ID
    ,dib.C_NAME
  FROM T_OSZTALYCSOPORT ocs
    INNER JOIN T_DICTIONARYITEMBASE dib ON dib.ID = ocs.C_EVFOLYAMTIPUSA AND dib.ID NOT IN(1303,1304,1305,1306,7366)--1-4 évfolyamok és összevont osztály
    INNER JOIN T_OSZTALY o ON o.ID = ocs.ID
  WHERE ocs.C_FELADATELLATASIHELYID = @feladatEllatasiHelyId AND ocs.C_KEPZESIFORMA = 1096 --Nappali rendszerű iskolai oktatás
  UNION
  SELECT DISTINCT 
     dib.ID
    ,dib.C_NAME
  FROM T_TANULOTANUGYIADATOK tta
    INNER JOIN T_TANULOCSOPORT tcs ON tcs.ID = tta.C_TANULOCSOPORTID
    INNER JOIN T_OSZTALYCSOPORT ocs ON ocs.ID = tcs.C_OSZTALYCSOPORTID AND ocs.C_FELADATELLATASIHELYID = @feladatEllatasiHelyId 
      AND ocs.C_KEPZESIFORMA = 1096 --Nappali rendszerű iskolai oktatás
    INNER JOIN T_OSZTALY o ON o.ID = ocs.ID
    INNER JOIN T_DICTIONARYITEMBASE dib ON dib.ID = tta.C_TANULOEVFOLYAMTIPUSID
  WHERE tta.C_TANULOEVFOLYAMTIPUSID NOT IN (1303,1304,1305,1306,7366) --1-4 évfolyamok és összevont osztály

  SET @cols =
    STUFF((SELECT ',' + QUOTENAME(Evfolyamnev)
           FROM #IntezmenyEvfolyamok
           ORDER BY ID
           FOR XML PATH('')),1,1,'')

  INSERT INTO #ErintettTanulok (
     TanuloId
    ,Evfolyam
    ,Neme
    ,TanuloNev
    ,OktatasiAzonosito
    ,TanuloOsztalyNev
    ,TanuloOsztalyId
    ,IsKozepesMiatt
    ,IsRontasMiatt
  )
  SELECT * FROM fnGetLemorzsolodottTanulokByFelhely (@feladatEllatasiHelyId, @tanevId, @isFelevi, @osztalyzatTipusTypeID)

  INSERT INTO  #TanuloErtekeles
  SELECT 
     te.ID
    ,C_TANULOID
    ,C_ERTEKELESOSZTALYZATID
    ,C_TIPUSID
  FROM T_TANULOERTEKELES te
    INNER JOIN #ErintettTanulok fht ON fht.TanuloId=te.C_TANULOID
    INNER JOIN T_TANTARGY tgy ON tgy.ID = te.C_TANTARGYID AND tgy.C_ESLTANTARGYKATEGORIAID IS NOT NULL
  WHERE te.C_TIPUSID=@ertekelesTipus
  
  DECLARE @Kategoria nvarchar(500) 
  
  ----------------------------------------------------------------------
  -- PRINT '1'
  ----------------------------------------------------------------------
  -- Összes
  ----------------------------------------------------------------------
  
  SET @Kategoria = 'Osszesen'
  
  INSERT INTO #Tanulok(
     TanuloNev 
    ,Neme
    ,Evfolyam 
    ,Kategoria
  ) SELECT DISTINCT
     TanuloNev + ' - ' + OktatasiAzonosito + '; ' + TanuloOsztalyNev
    ,Neme
    ,Evfolyam
    ,@Kategoria
  FROM #ErintettTanulok 
 
  ----------------------------------------------------------------------
  -- PRINT '2'
  ----------------------------------------------------------------------
  -- Lány
  ----------------------------------------------------------------------
   
  SET @Kategoria = 'Lany'
   
  INSERT INTO #Tanulok(
     TanuloNev 
    ,Neme
    ,Evfolyam 
    ,Kategoria
  ) SELECT DISTINCT
     TanuloNev + ' - ' + OktatasiAzonosito + '; ' + TanuloOsztalyNev
    ,Neme
    ,Evfolyam
    ,@Kategoria
  FROM #ErintettTanulok 
  WHERE Neme = 5

  ----------------------------------------------------------------------
  -- PRINT '3'
  ----------------------------------------------------------------------
  -- Összes rontott
  ----------------------------------------------------------------------
 
  SET @Kategoria = 'AFelevErtekelesenelMinositesenelATanuloEgyTizedesjegyigSzamitottTanulmanyiAtlagaAMagatartasEsSzorgalomErtekelesetMinositesetNemBeleszamitvaNemEriElKozepes3Szintet'
  
  INSERT INTO #Tanulok(
     TanuloNev 
    ,Neme
    ,Evfolyam 
    ,Kategoria
  ) SELECT DISTINCT
     TanuloNev + ' - ' + OktatasiAzonosito + '; ' + TanuloOsztalyNev
    ,Neme
    ,Evfolyam
    ,@Kategoria
  FROM #ErintettTanulok 
  WHERE IsKozepesMiatt = 1

  ----------------------------------------------------------------------
  -- PRINT '4'
  ----------------------------------------------------------------------
  -- Legalább 1.1-et rontott
  ----------------------------------------------------------------------
  
  SET @Kategoria = 'AzEvVegiJegyekAlapjanAFeleviJegyekhezKepestLegalabb11NyiAtlagotRontoTanulokSzama'

  INSERT INTO #Tanulok(
     TanuloNev 
    ,Neme
    ,Evfolyam 
    ,Kategoria
  ) SELECT DISTINCT
     TanuloNev + ' - ' + OktatasiAzonosito + '; ' + TanuloOsztalyNev
    ,Neme
    ,Evfolyam
    ,@Kategoria
  FROM #ErintettTanulok 
  WHERE IsRontasMiatt = 1
  
  ----------------------------------------------------------------------
  -- PRINT '5'
  ----------------------------------------------------------------------
  -- egy, vagy több tantárgyból elégtelen osztályzat
  ----------------------------------------------------------------------

  SET @Kategoria = 'AFelevErtekelesenelMinositesenelATanuloEgyVagyTobbTantargybolElegtelen1OsztalyzatotKapott'
  
  INSERT INTO #Tanulok(
     TanuloNev 
    ,Neme
    ,Evfolyam 
    ,Kategoria
  ) SELECT DISTINCT
     TanuloNev + ' - ' + OktatasiAzonosito + '; ' + TanuloOsztalyNev
    ,Neme
    ,Evfolyam
    ,@Kategoria
  FROM #TanuloErtekeles te
    INNER JOIN #ErintettTanulok fht ON fht.TanuloId=te.Tanulo
  WHERE te.Tipus = @ertekelesTipus AND te.Ertekeles = 1501
  
  ----------------------------------------------------------------------
  -- PRINT '6'
  ----------------------------------------------------------------------
  -- félév, magatartás, 2
  ----------------------------------------------------------------------
  
  SET @Kategoria = 'AFelevMagatartasanakErtekelesenelMinositesenelATanuloRossz2ErtekelestKapott'
  
  INSERT INTO #Tanulok(
     TanuloNev 
    ,Neme
    ,Evfolyam 
    ,Kategoria
  ) SELECT DISTINCT
     TanuloNev + ' - ' + OktatasiAzonosito + '; ' + TanuloOsztalyNev
    ,Neme
    ,Evfolyam
    ,@Kategoria
  FROM #ErintettTanulok fht
    INNER JOIN T_TANULOERTEKELES te ON te.C_TANULOID=fht.TanuloId AND te.C_ISMAGATARTASSZORGALOM = 'T'
      AND (te.C_MAGATARTASERTEKID=1558 OR te.C_MAGATARTASOSZTALYZATID=1502) AND te.C_TIPUSID = @ertekelesTipus
   
  ----------------------------------------------------------------------
  -- PRINT '7'
  ----------------------------------------------------------------------
  -- félév, szorgalom, 2
  ----------------------------------------------------------------------
  
  SET @Kategoria = 'AFelevSzorgalmanakErtekelesenelMinositesenelATanuloHanyag2ErtekelestKapott'
  
  INSERT INTO #Tanulok(
     TanuloNev 
    ,Neme
    ,Evfolyam 
    ,Kategoria
  ) SELECT DISTINCT
     TanuloNev + ' - ' + OktatasiAzonosito + '; ' + TanuloOsztalyNev
    ,Neme
    ,Evfolyam
    ,@Kategoria
  FROM #ErintettTanulok fht
    INNER JOIN T_TANULOERTEKELES te ON te.C_TANULOID=fht.TanuloId AND te.C_ISMAGATARTASSZORGALOM = 'T'
      AND (te.C_SZORGALOMERTEKID = 1562 OR te.C_SZORGALOMOSZTALYZATID=1502) AND te.C_TIPUSID = @ertekelesTipus
  
  ----------------------------------------------------------------------
  -- PRINT '8'
  ----------------------------------------------------------------------
  -- adott évben évismétlés 
  ----------------------------------------------------------------------
  
  SET @Kategoria = 'AzAdottTanitasiEvbenEvismetlesreKotelezett'
  IF @isFelevi = 0 
  BEGIN
    INSERT INTO #Tanulok(
       TanuloNev
      ,Neme
      ,Evfolyam 
      ,Kategoria
    ) SELECT DISTINCT
       TanuloNev + ' - ' + OktatasiAzonosito + '; ' + TanuloOsztalyNev
      ,Neme
      ,Evfolyam
      ,@Kategoria
    FROM #ErintettTanulok fht
      INNER JOIN (
        SELECT COUNT(DISTINCT fht.TanuloId) db,fht.TanuloId
        FROM #ErintettTanulok fht
          INNER JOIN #TanuloErtekeles te ON te.Tanulo=fht.TanuloId AND te.Ertekeles=1501
        GROUP BY fht.TanuloId
        HAVING COUNT(*)>=4) x ON x.TanuloId = fht.TanuloId
  END

  ----------------------------------------------------------------------
  -- PRINT '9'
  ----------------------------------------------------------------------
  -- Félévben 50 órát elérő igazolatlan hiányzás 
  ----------------------------------------------------------------------
  
  SET @Kategoria = 'AFelevbenATanulo50OratMeghaladoHianyzassalRendelkezik'
  
  INSERT INTO #Tanulok(
     TanuloNev
    ,Neme 
    ,Evfolyam 
    ,Kategoria
  ) SELECT DISTINCT
     TanuloNev + ' - ' + OktatasiAzonosito + '; ' + TanuloOsztalyNev
    ,fht.Neme
    ,Evfolyam
    ,@Kategoria
  FROM #ErintettTanulok fht
    INNER JOIN (
      SELECT fht.TanuloId AS Tanulo FROM T_TANULOMULASZTAS tm
        INNER JOIN #ErintettTanulok fht on fht.TanuloId=tm.C_ORATANULOIID
        INNER JOIN T_TANITASIORA tao on tao.ID=tm.C_TANITASIORAKID AND tao.C_DATUM >= @FelevKezdete AND tao.C_DATUM<@FelevVege
        LEFT JOIN T_CSOPORT cs ON cs.ID = tao.C_OSZTALYCSOPORTID AND cs.C_TIPUSA NOT IN (SELECT ID FROM fnGetTanoraiCeluCsoportTipusok(@tanevId))
      WHERE tm.C_IGAZOLT='F' AND cs.ID IS NULL
      GROUP BY fht.TanuloId
      HAVING COUNT(Tanuloid) > 50) x ON x.Tanulo = fht.TanuloId

  ----------------------------------------------------------------------
  -- PRINT '10'
  ----------------------------------------------------------------------
  -- Szülő kérésére magántanuló 
  ----------------------------------------------------------------------
  
  SET @Kategoria = 'AFelevbenSzuloiKeresreMagantanulovaValtTanulo'

  INSERT INTO #Tanulok(
     TanuloNev
    ,Neme 
    ,Evfolyam 
    ,Kategoria
  ) SELECT DISTINCT
     TanuloNev + ' - ' + OktatasiAzonosito + '; ' + TanuloOsztalyNev
    ,fht.Neme
    ,Evfolyam
    ,@Kategoria
  FROM #ErintettTanulok fht
    INNER JOIN T_TANULOCSOPORT tcs ON tcs.C_TANULOID=fht.TanuloId AND tcs.C_OSZTALYCSOPORTID=fht.TanuloOsztalyId
    INNER JOIN T_TANULOTANUGYIADATOK tta ON tcs.ID=tta.C_TANULOCSOPORTID AND tta.C_MAGANTANULOSAGANAKOKAID IN (663, 664)

  ----------------------------------------------------------------------
  -- PRINT '11'
  ----------------------------------------------------------------------
  -- Menekült, menedékjoggal rendelkező
  ----------------------------------------------------------------------  
  
  SET @Kategoria = 'AFelevbenMenekultOltalmazottMenedekesTanulokSzama'

  INSERT INTO #Tanulok(
     TanuloNev
    ,Neme 
    ,Evfolyam 
    ,Kategoria
  ) SELECT DISTINCT
     TanuloNev + ' - ' + OktatasiAzonosito + '; ' + TanuloOsztalyNev
    ,fht.Neme
    ,Evfolyam
    ,@Kategoria
  FROM #ErintettTanulok fht
    INNER JOIN T_TANULO t ON t.C_MENEDEKJOGGALRENDELKEZO='T' AND fht.TanuloId=t.ID
  
  ----------------------------------------------------------------------
  -- PRINT '12'
  ----------------------------------------------------------------------
  -- Félévben veszélyeztetett tanulók száma
  ----------------------------------------------------------------------  
  
  SET @Kategoria = 'AFelevbenVeszelyezeztetteValtTanulokSzama'

  INSERT INTO #Tanulok(
     TanuloNev
    ,Neme 
    ,Evfolyam 
    ,Kategoria
  ) SELECT DISTINCT
     TanuloNev + ' - ' + OktatasiAzonosito + '; ' + TanuloOsztalyNev
    ,fht.Neme
    ,Evfolyam
    ,@Kategoria
  FROM #ErintettTanulok fht
    INNER JOIN T_TANULO t ON t.ID=fht.TanuloId AND t.C_VESZELYEZTETETT='T'

  ----------------------------------------------------------------------
  -- PRINT '13'
  ----------------------------------------------------------------------
  -- ideiglenes hatállyal elhelyezett vagy nevelésbe vett tanulók
  ----------------------------------------------------------------------  
  
  SET @Kategoria = 'AFelevbenIdeiglenesHatallyalElhelyezettVagyNevelesbeVettTanulokSzama'

  INSERT INTO #Tanulok(
     TanuloNev
    ,Neme 
    ,Evfolyam 
    ,Kategoria
  ) SELECT DISTINCT
     TanuloNev + ' - ' + OktatasiAzonosito + '; ' + TanuloOsztalyNev
    ,fht.Neme
    ,Evfolyam
    ,@Kategoria
  FROM #ErintettTanulok fht
    INNER JOIN T_TANULO t ON t.C_ALLAMIGONDOZOTT='T' AND fht.TanuloId=t.ID

  ----------------------------------------------------------------------
  -- PRINT '14'
  ----------------------------------------------------------------------
  -- legalább 2 feltétel teljesül
  ----------------------------------------------------------------------  

  INSERT INTO #KetFeltetelTanulok
  SELECT DISTINCT
     ftt.TanuloId
    ,ftt.Evfolyam
    ,ftt.Neme
    ,ftt.TanuloNev
    ,ftt.OktatasiAzonosito
    ,ftt.TanuloOsztalyNev
    ,IIF((SELECT COUNT(1)
         FROM T_TANULOMULASZTAS tm 
           INNER JOIN T_TANITASIORA tno ON tno.ID = tm.C_TANITASIORAKID AND tno.C_DATUM > @FelevKezdete AND tno.C_DATUM < @FelevVege
           LEFT JOIN T_CSOPORT cs ON cs.ID = tno.C_OSZTALYCSOPORTID
         WHERE (cs.ID IS NULL OR cs.C_TIPUSA IN (SELECT ID FROM fnGetTanoraiCeluCsoportTipusok(@tanevId))) AND tm.C_IGAZOLT='T' AND tm.C_TIPUS = 1500 AND tm.C_ORATANULOIID = ftt.TanuloId) > 100, 1, 0) AS IsHianyzasMiatt
    ,IIF((SELECT COUNT(1)
         FROM T_TANULO t
         WHERE t.ID = ftt.TanuloId
           AND (t.C_SAJATOSNEVELESU='T' OR t.C_BTMPROBLEMAS='T' OR t.C_HATRANYOSHELYZETU IN (1122, 1123))) > 0, 1, 0) AS IsKiemeltMiatt
    ,IIF((SELECT COUNT(1)
         FROM T_TANULO t
         WHERE t.ID = ftt.TanuloId 
           AND t.C_RENDSZERESGYERMEKVEDELMIKEDV IS NOT NULL) > 0, 1, 0) AS IsGyermekVedelemMiatt
    ,IIF((SELECT COUNT(1)
         FROM T_FELHASZNALO t
          INNER JOIN T_TANULOCSOPORT tcs ON tcs.C_TANULOID=t.ID
          INNER JOIN T_OSZTALYCSOPORT ocs ON ocs.ID=tcs.C_OSZTALYCSOPORTID
          INNER JOIN T_TANULOTANUGYIADATOK tta ON tta.C_TANULOCSOPORTID = tcs.ID AND tta.C_ISESL16EVESUTANBELEPETT = 'T'
           INNER JOIN T_FELADATELLATASIHELY fh ON fh.ID=ocs.C_FELADATELLATASIHELYID AND fh.C_OKTATASINEVELESIFELADATTIPUS IN (1158,1178)
             AND fh.ID = @feladatEllatasiHelyId
         WHERE t.ID = ftt.TanuloId) > 0, 1, 0) AS IsAltalanosIskolaMiatt
  FROM #ErintettTanulok ftt
  DELETE kt FROM #KetFeltetelTanulok kt WHERE (kt.IsHianyzasMiatt + kt.IsKiemeltMiatt + kt.IsGyermekVedelemMiatt + kt.IsAltalanosIskolaMiatt) < 2

  SET @Kategoria = 'KettoFeltetelTelejesuleseEsetenLemorzsolodassalVeszelyeztetettTanulo'
  INSERT INTO #Tanulok(
     TanuloNev
    ,Neme 
    ,Evfolyam 
    ,Kategoria
  ) SELECT DISTINCT
     TanuloNev + ' - ' + OktatasiAzonosito + '; ' + TanuloOsztalyNev
    ,Neme
    ,Evfolyam
    ,@Kategoria
  FROM #KetFeltetelTanulok
  
  ----------------------------------------------------------------------
  -- PRINT '15'
  ----------------------------------------------------------------------
  -- kettő feltétel esetén ... félévben 100 órát elért igazolt hiányzás
  ----------------------------------------------------------------------  

  SET @Kategoria = 'EbbolAFelevben100OratEleroIgazoltHianyzassalRendelkezoTanulokSzama'

  INSERT INTO #Tanulok(
     TanuloNev
    ,Neme 
    ,Evfolyam 
    ,Kategoria
  ) SELECT DISTINCT
     TanuloNev + ' - ' + OktatasiAzonosito + '; ' + TanuloOsztalyNev
    ,kt.Neme
    ,Evfolyam
    ,@Kategoria
  FROM #KetFeltetelTanulok kt 
  WHERE kt.IsHianyzasMiatt = 1

  ----------------------------------------------------------------------
  -- PRINT '16'
  ----------------------------------------------------------------------
  -- kettő feltétel ... kiemelet figyelmet igénylő --sni, btmn, hh, 3h
  ----------------------------------------------------------------------  

  SET @Kategoria = 'EbbolKiemeltFigyelmetIgenyloTanulokSzamaAKiemeltenTehetsegesTanulokKivetelevel'

  INSERT INTO #Tanulok(
     TanuloNev
    ,Neme 
    ,Evfolyam 
    ,Kategoria
  ) SELECT DISTINCT
     TanuloNev + ' - ' + OktatasiAzonosito + '; ' + TanuloOsztalyNev
    ,kt.Neme
    ,Evfolyam
    ,@Kategoria
  FROM #KetFeltetelTanulok kt 
  WHERE kt.IsKiemeltMiatt = 1

  ----------------------------------------------------------------------
  -- PRINT '17'
  ----------------------------------------------------------------------
  -- kettő feltétel ... --rendszeres gyermekvédelmi támogatás
  ----------------------------------------------------------------------  

  SET @Kategoria = 'EbbolRendszeresGyermekvedelmiKedvezmenybenReszesuloTanulokSzama'

  INSERT INTO #Tanulok(
     TanuloNev
    ,Neme 
    ,Evfolyam 
    ,Kategoria
  ) SELECT DISTINCT
     TanuloNev + ' - ' + OktatasiAzonosito + '; ' + TanuloOsztalyNev
    ,kt.Neme
    ,Evfolyam
    ,@Kategoria
  FROM #KetFeltetelTanulok kt 
  WHERE kt.IsGyermekVedelemMiatt = 1

  ----------------------------------------------------------------------
  -- PRINT '18'
  ----------------------------------------------------------------------
  -- kettő feltétel ... alapfokú oktatásban 16
  ----------------------------------------------------------------------  

  SET @Kategoria = 'EbbolAlapfokuOktatasbanBetoltotteA16Eletevet'

  INSERT INTO #Tanulok(
     TanuloNev
    ,Neme 
    ,Evfolyam 
    ,Kategoria
  ) SELECT DISTINCT
     TanuloNev + ' - ' + OktatasiAzonosito + '; ' + TanuloOsztalyNev
    ,kt.Neme
    ,Evfolyam
    ,@Kategoria
  FROM #KetFeltetelTanulok kt 
  WHERE kt.IsAltalanosIskolaMiatt = 1
  
  INSERT INTO #TanulokOsszes(
     Kategoria 
    ,Osszes 
    ,OsszesLany 
  ) SELECT
     Kategoria
    ,COUNT(TanuloNev)
    ,SUM(IIF(Neme = 5,1,0))
  FROM #Tanulok
  GROUP BY Kategoria

  DECLARE @query nvarchar(max)
  set @query = 
  'SELECT 
      KategoriaNev
     ,Sorrend
     ,rn
     ,' + @cols + ' 
     ,Osszes
     ,OsszesLany
  INTO #RetTable
  FROM (
    SELECT 
        k.KategoriaNev
       ,t.TanuloNev
       ,ROW_NUMBER() OVER (PARTITION BY t.Kategoria,t.Evfolyam ORDER BY t.TanuloNev) rn
       ,dib.C_NAME as Evfolyam
       ,k.Sorrend
       ,Ossz.Osszes
       ,Ossz.OsszesLany
      FROM #Kategoria k
        LEFT JOIN #Tanulok t ON t.Kategoria = k.KategoriaNev
        LEFT JOIN T_DICTIONARYITEMBASE dib ON dib.ID = t.Evfolyam
        LEFT JOIN #TanulokOsszes ossz ON ossz.Kategoria = k.KategoriaNev
    ) x 
    PIVOT (
      MIN(TanuloNev)
      FOR Evfolyam IN (' + @cols + ')
    ) p 

    SELECT 
       KategoriaNev as Leiras
      ,'+@cols+'
      ,Osszes as Összesen
      ,OsszesLany as Lány
    FROM #RetTable
    ORDER BY Sorrend,rn'

  EXEC sp_executesql @query
  END
GO
