DROP PROCEDURE IF EXISTS dbo.sp_FizikaiTorlesTantargyfelosztas
GO

-- =============================================
-- Description:  <Fizikailag töröljük az intézmény adott tanévére a tantárgyfelosztást>
-- =============================================
CREATE PROCEDURE [dbo].[sp_FizikaiTorlesTantargyfelosztas]
   @pIntezmenyId  INT
  ,@pTanevId    INT
  ,@pUserId    INT

AS
BEGIN
SET NOCOUNT ON;
    
  UPDATE T_ORARENDIORA_OSSZES SET
     C_FOGLALKOZASID = NULL
    ,SERIAL += 1
    ,LASTCHANGED = GETDATE()
    ,MODIFIER = @pUserId
  FROM T_ORARENDIORA_OSSZES
  WHERE C_INTEZMENYID = @pIntezmenyId
    AND C_TANEVID = @pTanevId
    AND C_FOGLALKOZASID IS NOT NULL
      
  UPDATE T_TANITASIORA_OSSZES SET
     C_FOGLALKOZASID = NULL
    ,SERIAL += 1
    ,LASTCHANGED = GETDATE()
    ,MODIFIER = @pUserId
  FROM T_TANITASIORA_OSSZES
  WHERE C_INTEZMENYID = @pIntezmenyId
    AND C_TANEVID = @pTanevId
    AND C_FOGLALKOZASID IS NOT NULL

  DELETE fat
  FROM T_FOGLALKOZASAMITANULO_OSSZES fat
    INNER JOIN T_FOGLALKOZAS_OSSZES f ON fat.C_FOGLALKOZASID = f.ID AND f.C_TANEVID = fat.C_TANEVID
  WHERE fat.C_TANEVID = @pTanevId
      
  DELETE FROM
    T_FOGLALKOZAS_OSSZES
  WHERE C_INTEZMENYID = @pIntezmenyId
    AND C_TANEVID = @pTanevId;

END

GO

