﻿-- =============================================
-- Description:  <Előszedjük a tanuló összes közösségi szolgálat óraszámát>
-- =============================================
DROP PROCEDURE IF EXISTS [dbo].[sp_GetKozossegiSzolgalatOsszesOraszam]
GO

CREATE PROCEDURE [dbo].[sp_GetKozossegiSzolgalatOsszesOraszam]
   @pIntezmenyId AS INT
  ,@pTanuloId AS INT
AS
BEGIN

  SET NOCOUNT ON;  
  
  SELECT IIF(SUM(KozossegiSzolgalat.C_ORASZAM) IS NULL, 0, SUM(KozossegiSzolgalat.C_ORASZAM))
  FROM 
    T_FELHASZNALO_OSSZES Tanulo
  LEFT JOIN (
    SELECT DISTINCT
       Tanulo.C_OKTATASIAZONOSITO      OktatasiAzonosito
    FROM 
      T_FELHASZNALO_OSSZES Tanulo
    WHERE 
        Tanulo.TOROLT = 'F'
      AND Tanulo.ID = @pTanuloId
    ) CurrentTanulo ON 
      CurrentTanulo.OktatasiAzonosito IS NOT NULL
  LEFT JOIN 
    T_TANULOKOZOSSEGISZOLGALAT_OSSZES KozossegiSzolgalat ON
        KozossegiSzolgalat.C_TANULOID = Tanulo.ID
      AND KozossegiSzolgalat.C_INTEZMENYID = @pIntezmenyId
      AND KozossegiSzolgalat.TOROLT = 'F'
  WHERE 
        Tanulo.C_OKTATASIAZONOSITO = CurrentTanulo.OktatasiAzonosito
    AND Tanulo.C_INTEZMENYID = @pIntezmenyId
    AND Tanulo.TOROLT = 'F'
      
END

GO

