DROP PROCEDURE IF EXISTS dbo.sp_GetOraMentessegList
GO

CREATE PROCEDURE [dbo].[sp_GetOraMentessegList]
  @osztalyCsoportId  int,
  @start        datetime,
  @end        datetime,
  @intezmenyId    int,
  @tanevId      int
AS
BEGIN
  SET NOCOUNT ON;
  DECLARE 
     @JogviszonyList NVARCHAR(MAX)
    ,@jogviszonyDb int
    ,@SzakmaiList NVARCHAR(MAX)
    ,@szakmaiDb int

  CREATE TABLE #tmp (Nev nvarchar(250), SzakmaiGyak char(1), Jogviszony char(1))
  INSERT INTO #tmp (Nev, SzakmaiGyak, Jogviszony)
    SELECT
       f.C_NYOMTATASINEV
      ,tta.C_SZAKMAIGYAKORLATON
      ,ISNULL(jogviszony.C_JOGVISZONYATSZUNETELTETO, tta.C_JOGVISZONYATSZUNETELTETO)
    FROM T_TANULOCSOPORT tcs
      INNER JOIN T_TANULO t ON t.ID = tcs.C_TANULOID
      INNER JOIN fnGetOsztalyCsoportTanuloinakTanugyiAdatai(@osztalyCsoportId,@end) tta ON tta.TanuloId=t.ID
      INNER JOIN T_FELHASZNALO f ON f.ID = t.ID
      OUTER APPLY (
        SELECT TOP (1)
          IIF(jogviszony.C_KEZDETE <= @start AND DATEADD(day, 1, jogviszony.C_VEGE) > @end , 'T', 'F') C_JOGVISZONYATSZUNETELTETO
        FROM T_JOGVISZONYSZUNETELTETES_OSSZES jogviszony
        WHERE 
              jogviszony.C_TANULOTANUGYIADATOKID = tta.ID 
          AND jogviszony.C_TANULOID = tta.TanuloId
          AND jogviszony.TOROLT = 'F'
          AND jogviszony.C_INTEZMENYID = tcs.C_INTEZMENYID
          AND jogviszony.C_TANEVID = tcs.C_TANEVID
        ORDER BY C_JOGVISZONYATSZUNETELTETO DESC
      ) jogviszony
    WHERE tcs.C_BELEPESDATUM <= GETDATE() AND (tcs.C_KILEPESDATUM IS NULL OR tcs.C_KILEPESDATUM >= GETDATE()) AND tcs.c_osztalycsoportid = @osztalyCsoportId

  SELECT @SzakmaiList =  ISNULL(@SzakmaiList + ', ', '') + Nev FROM #tmp WHERE SzakmaiGyak = 'T'
  SELECT @szakmaiDb = COUNT(*) FROM #tmp WHERE SzakmaiGyak='T'
  SELECT @JogviszonyList =  COALESCE(@JogviszonyList + ', ', '') + Nev FROM #tmp WHERE Jogviszony = 'T'
  SELECT @jogviszonyDb = COUNT(*) FROM #tmp WHERE Jogviszony='T'

  SELECT
     @szakmaiDb as SzakmaiGyakDb
    ,@SzakmaiList as SzakmaiGyakNevSor
    ,@jogviszonyDb as JogviszonyDb
    ,@JogviszonyList as JogviszonyNevSor

END
GO