-- =============================================
-- Description:  <Előszedjük a pedagógusok IKT kompetenciáit>
-- =============================================
DROP PROCEDURE IF EXISTS sp_GetPedagogusIKTAdatszolgaltatasForGrid
GO

CREATE PROCEDURE sp_GetPedagogusIKTAdatszolgaltatasForGrid
  @pIntezmenyId INT,
  @pTanevId INT
AS
BEGIN

  SET NOCOUNT ON;

  SELECT
    Alkalmazott.ID AS                      ID,
    Felhasznalo.C_NYOMTATASINEV AS                TanarNev,
    Felhasznalo.C_ANYJANEVE AS                  AnyjaNeve,
    Felhasznalo.C_SZULETESIDATUM AS                SzuletesiIdo,
    PedagogusIKTAdatszolgatlatas.C_IKTKOMPETENCIASZINTJE AS    IKTKompetenciaSzint,
    PedagogusIKTAdatszolgatlatas.C_IKTESZKOZHASZNALATMODJA AS  IKTEszkozhasznalatModja,
    PedagogusIKTAdatszolgatlatas.C_ELSODLEGESIKTESZKOZE AS    ElsodlegesIKTEszkoz
  FROM
    T_ALKALMAZOTT_OSSZES  AS Alkalmazott
  LEFT JOIN
    T_FELHASZNALO_OSSZES AS Felhasznalo ON
      Felhasznalo.ID = Alkalmazott.ID AND Felhasznalo.TOROLT = 'F'
      AND Felhasznalo.C_INTEZMENYID = Alkalmazott.C_ALINTEZMENYID AND Felhasznalo.C_TANEVID = Alkalmazott.C_ALTANEVID
  LEFT JOIN
    T_PEDAGOGUSIKTADATSZOLGALTATAS_OSSZES AS PedagogusIKTAdatszolgatlatas ON
      PedagogusIKTAdatszolgatlatas.C_ALKALMAZOTTID = Alkalmazott.ID AND PedagogusIKTAdatszolgatlatas.TOROLT = 'F'
      AND PedagogusIKTAdatszolgatlatas.C_INTEZMENYID = Alkalmazott.C_ALINTEZMENYID AND PedagogusIKTAdatszolgatlatas.C_TANEVID = Alkalmazott.C_ALTANEVID
  WHERE
    Alkalmazott.C_ALINTEZMENYID = @pIntezmenyId AND
    Alkalmazott.C_ALTANEVID = @pTanevId AND
    Alkalmazott.TOROLT = 'F'
END
GO
