DROP PROCEDURE IF EXISTS [dbo].[sp_GetTanuloiEgyebAdatok]
GO

CREATE PROCEDURE [dbo].[sp_GetTanuloiEgyebAdatok]
   @pTanuloId    INT
  ,@pTanevId    INT
  ,@pIntezmenyId  INT
  ,@pOsztalyId INT = NULL
AS
BEGIN

  SET NOCOUNT ON;

  SELECT
     tta.C_TANKOTELEZETT AS IsTankotelezett
    ,tta.C_TANKOTELEZETTSEGVEGE AS TankotelezettsegVege
    ,tta.C_MAGANTANULO AS IsMagantanulo
    ,tta.C_MAGANTANULOSAGANAKOKAID as MagantanulosagOka
    ,tta.C_JOGVISZONYATSZUNETELTETO AS JogviszonyatSzunetelteto
    ,fh.C_TAJSZAM AS TajSzam
    ,ISNULL(dibAllamp.C_NAME,'') AS Allampolgarsag
  FROM T_TANULO_OSSZES t
    INNER JOIN T_FELHASZNALO_OSSZES fh ON fh.ID = t.ID AND fh.TOROLT = 'F'
    INNER JOIN T_TANULOCSOPORT_OSSZES tcs ON tcs.C_TANULOID=t.ID AND tcs.TOROLT='F' AND tcs.C_BELEPESDATUM<=GETDATE() AND (tcs.C_KILEPESDATUM IS NULL OR tcs.C_KILEPESDATUM>GETDATE())
    INNER JOIN T_OSZTALY_OSSZES o ON o.ID=tcs.C_OSZTALYCSOPORTID AND o.TOROLT='F' 
    INNER JOIN T_TANULOTANUGYIADATOK tta ON tta.C_TANULOCSOPORTID=tcs.ID
    LEFT JOIN T_DICTIONARYITEMBASE_OSSZES dibAllamp ON dibAllamp.ID = fh.C_ALLAMPOLGARSAGA AND dibAllamp.C_TANEVID = @pTanevId AND dibAllamp.TOROLT = 'F'
  WHERE t.ID = @pTanuloId 
    AND t.TOROLT = 'F'
    AND (@pOsztalyId is NULL OR o.ID = @pOsztalyId) 

END
GO