DROP PROCEDURE IF EXISTS uspCloneTanulo
GO

CREATE PROCEDURE uspCloneTanulo 
   @tanuloId int
  ,@trgTanevId int
  ,@intezmenyId int
  ,@srcTanevId int
  ,@felhasznaloId int
AS BEGIN
  SET NOCOUNT ON;
  DECLARE @newId int

  SELECT
    @newId = fh.ID
  FROM T_FELHASZNALO_OSSZES fh
    INNER JOIN T_TANULO_OSSZES t ON t.ID = fh.ID AND t.TOROLT = 'F' AND t.C_ALTANEVID = @trgTanevId
  WHERE fh.ELOZOTANEVIREKORDID = @tanuloId AND fh.C_TANEVID = @trgTanevId AND fh.TOROLT = 'F'

  IF @newId IS NOT NULL BEGIN
    SELECT @newId AS [newId]
    RETURN
  END
  DECLARE @IdpEgyediazonosito uniqueidentifier =  (SELECT ISNULL(fh.C_IDPEGYEDIAZONOSITO, NEWID())
    FROM T_FELHASZNALO_OSSZES fh
    LEFT JOIN T_FELHASZNALO_OSSZES fh2 ON fh.C_IDPEGYEDIAZONOSITO = fh2.C_IDPEGYEDIAZONOSITO AND fh2.C_TANEVID = @trgTanevId AND fh2.TOROLT = 'F'
    WHERE fh.ID = @tanuloId AND fh.C_TANEVID = @srcTanevId AND fh.TOROLT = 'F' AND fh2.ID IS NULL)--ha letezik mar az IDPEGYEDIAZONOSITO a cel tanevben akkor ujat generalunk

  INSERT INTO T_FELHASZNALO (
     C_NEME
    ,C_SZULETESIDATUM
    ,C_SZULETESINEV
    ,C_ANYJANEVE
    ,C_SZULETESIHELY
    ,C_TAJSZAM
    ,C_ALLAMPOLGARSAGA
    ,C_KERESESINEV
    ,C_SZULETESIORSZAG
    ,C_SZULETESINEVSORREND
    ,C_ANYJANEVESORREND
    ,C_ALAPERTELMEZETTLCID
    ,C_LATASSERULTWEBHASZNALATA
    ,C_SMSSZAM
    ,C_SMSSZINKRONIZALT
    ,C_KELLADSZINKRONIZALAS
    ,C_DMSTARTTIME
    ,C_NYOMTATASINEV
    ,C_UTONEV
    ,C_VEZETEKNEV
    ,C_ELOTAG
    ,C_ANYANYELVE
    ,C_IGAZOLVANYSZAM
    ,C_IGAZOLVANYTIPUSA
    ,C_NEVSORREND
    ,C_NYILVANTARTASISZAM
    ,C_NYILVANTARTASKEZDETE
    ,C_OKTATASIAZONOSITO
    ,C_OMKOD
    ,C_ALAIRAS
    ,C_PROFILKEP
    ,C_KIRAZONOSITO
    ,C_ALLAMPOLGARSAGA2
    ,C_FENNTARTOAZONOSITO
    ,C_IMPORTALT
    ,C_INTEZMENYID
    ,C_TANEVID
    ,TOROLT
    ,SERIAL
    ,LASTCHANGED
    ,CREATED
    ,MODIFIER
    ,CREATOR
    ,ELOZOTANEVIREKORDID
    ,C_BELUGYALTALAZONOSITOTT
    ,C_UTOLSOADATFRISSITESIDOPONTJA
    ,C_EGYEDIAZONOSITO
    ,C_KRETAKURZUSOKLEVELSZAM
    ,C_MEGJEGYZES
    ,C_IDPEGYEDIAZONOSITO
    ,C_ISCOVIDFERTOZOTT
    ,C_ADOAZONOSITOJEL
    ,C_COVIDFERTOZESKEZDETEDATE
    ,C_ANYJAUTONEVE
    ,C_ANYJAVEZETEKNEVE
    ,C_SZULETESIUTONEV
    ,C_SZULETESIVEZETEKNEV
    ,C_ANYJANEVEELOTAG
    ,C_SZULETESINEVELOTAG
    ,C_ISADOAZONOSITONELKUL
    ,C_ISOKTAZONNELKUL
    ,C_ISTAJSZAMNELKUL
  ) SELECT
     fh.C_NEME AS C_NEME -- * int
    ,fh.C_SZULETESIDATUM AS C_SZULETESIDATUM -- * datetime
    ,fh.C_SZULETESINEV AS C_SZULETESINEV -- * nvarchar(64)
    ,fh.C_ANYJANEVE AS C_ANYJANEVE -- * nvarchar(64)
    ,fh.C_SZULETESIHELY AS C_SZULETESIHELY -- nvarchar(50)
    ,fh.C_TAJSZAM AS C_TAJSZAM -- nvarchar(9)
    ,fh.C_ALLAMPOLGARSAGA AS C_ALLAMPOLGARSAGA -- * int
    ,fh.C_KERESESINEV AS C_KERESESINEV -- nvarchar(61)
    ,fh.C_SZULETESIORSZAG AS C_SZULETESIORSZAG -- * int
    ,fh.C_SZULETESINEVSORREND AS C_SZULETESINEVSORREND -- * char(1)
    ,fh.C_ANYJANEVESORREND AS C_ANYJANEVESORREND -- * char(1)
    ,fh.C_ALAPERTELMEZETTLCID AS C_ALAPERTELMEZETTLCID -- int
    ,fh.C_LATASSERULTWEBHASZNALATA AS C_LATASSERULTWEBHASZNALATA -- * char(1)
    ,fh.C_SMSSZAM AS C_SMSSZAM -- int
    ,fh.C_SMSSZINKRONIZALT AS C_SMSSZINKRONIZALT -- char(1)
    ,fh.C_KELLADSZINKRONIZALAS AS C_KELLADSZINKRONIZALAS -- * char(1)
    ,fh.C_DMSTARTTIME AS C_DMSTARTTIME -- nvarchar(5)
    ,fh.C_NYOMTATASINEV AS C_NYOMTATASINEV -- * nvarchar(255)
    ,fh.C_UTONEV AS C_UTONEV -- nvarchar(255)
    ,fh.C_VEZETEKNEV AS C_VEZETEKNEV -- nvarchar(255)
    ,fh.C_ELOTAG AS C_ELOTAG -- nvarchar(20)
    ,fh.C_ANYANYELVE AS C_ANYANYELVE -- * int
    ,fh.C_IGAZOLVANYSZAM AS C_IGAZOLVANYSZAM -- nvarchar(50)
    ,fh.C_IGAZOLVANYTIPUSA AS C_IGAZOLVANYTIPUSA -- int
    ,fh.C_NEVSORREND AS C_NEVSORREND -- char(1)
    ,fh.C_NYILVANTARTASISZAM AS C_NYILVANTARTASISZAM -- nvarchar(50)
    ,fh.C_NYILVANTARTASKEZDETE AS C_NYILVANTARTASKEZDETE -- * datetime
    ,fh.C_OKTATASIAZONOSITO AS C_OKTATASIAZONOSITO -- nvarchar(20)
    ,fh.C_OMKOD AS C_OMKOD -- nvarchar(20)
    ,fh.C_ALAIRAS AS C_ALAIRAS -- nvarchar(max)
    ,fh.C_PROFILKEP AS C_PROFILKEP -- varbinary(max)
    ,fh.C_KIRAZONOSITO AS C_KIRAZONOSITO -- nvarchar(20)
    ,fh.C_ALLAMPOLGARSAGA2 AS C_ALLAMPOLGARSAGA2 -- int
    ,fh.C_FENNTARTOAZONOSITO AS C_FENNTARTOAZONOSITO -- nvarchar(20)
    ,fh.C_IMPORTALT AS C_IMPORTALT -- * char(1)
    ,fh.C_INTEZMENYID AS C_INTEZMENYID -- * int
    ,@trgTanevId AS C_TANEVID -- * int
    ,fh.TOROLT AS TOROLT -- * char(1)
    ,0 AS SERIAL -- * int
    ,GETDATE() AS LASTCHANGED -- * datetime
    ,GETDATE() AS CREATED -- * datetime
    ,NULL AS MODIFIER -- int
    ,@felhasznaloId AS CREATOR -- int
    ,fh.ID AS ELOZOTANEVIREKORDID -- int
    ,fh.C_BELUGYALTALAZONOSITOTT AS C_BELUGYALTALAZONOSITOTT -- * char(1)
    ,fh.C_UTOLSOADATFRISSITESIDOPONTJA AS C_UTOLSOADATFRISSITESIDOPONTJA -- datetime
    ,fh.C_EGYEDIAZONOSITO AS C_EGYEDIAZONOSITO -- * nvarchar(36)
    ,fh.C_KRETAKURZUSOKLEVELSZAM AS C_KRETAKURZUSOKLEVELSZAM -- nvarchar(50)
    ,fh.C_MEGJEGYZES AS C_MEGJEGYZES -- nvarchar(2000)
    ,@IdpEgyediazonosito AS C_IDPEGYEDIAZONOSITO -- * uniqueidentifier
    ,fh.C_ISCOVIDFERTOZOTT AS C_ISCOVIDFERTOZOTT -- * char(1)
    ,fh.C_ADOAZONOSITOJEL AS C_ADOAZONOSITOJEL -- nvarchar(10)
    ,fh.C_COVIDFERTOZESKEZDETEDATE AS C_COVIDFERTOZESKEZDETEDATE -- datetime
    ,fh.C_ANYJAUTONEVE
    ,fh.C_ANYJAVEZETEKNEVE
    ,fh.C_SZULETESIUTONEV
    ,fh.C_SZULETESIVEZETEKNEV
    ,fh.C_ANYJANEVEELOTAG
    ,fh.C_SZULETESINEVELOTAG
    ,fh.C_ISADOAZONOSITONELKUL
    ,fh.C_ISOKTAZONNELKUL
    ,fh.C_ISTAJSZAMNELKUL
  FROM T_FELHASZNALO_OSSZES fh
  WHERE ID = @tanuloId
  
  SET @newId = SCOPE_IDENTITY()
  
  INSERT INTO T_TANULO (
     ID
    ,C_ALLAMIGONDOZOTT
    ,C_BANKSZAMLASZAM
    ,C_BEILLESZKEDESINEHEZSEG
    ,C_BEIRASINAPLOSORSZAM
    ,C_BEJARO
    ,C_DIAKIGAZOLVANYKELTE
    ,C_DIAKIGAZOLVANYSZAM
    ,C_ELOZOINTEZMENY
    ,C_EVISMETLO
    ,C_INGYENESTANKONVYELLATASA
    ,C_JOGVISZONYATSZUNETELTETO
    ,C_MAGANTANULO
    ,C_MAGANTANULOSAGANAKOKA
    ,C_MAGANTANULOSAGKEZDETE
    ,C_NAPLOSORSZAM
    ,C_POLGARISZERZODESES
    ,C_SZAKMAIGYAKORLATON
    ,C_SZOCIALISTAMOGATAS
    ,C_TANDIJATFIZETO
    ,C_TANKOTELEZETT
    ,C_TANKOTELEZETTSEGVEGE
    ,C_TANULOSZERZODESES
    ,C_TERITESIDIJATFIZETO
    ,C_TESTNEVELESTIPUSA
    ,C_VENDEG
    ,C_BTMPROBLEMAS
    ,C_DIAKSPORTKOROS
    ,C_EGYHAZKOZOSSEGE
    ,C_ETKEZESIKEDVEZMENY
    ,C_HALMOZOTTANFOGYATEKOS
    ,C_HATRANYOSHELYZETU
    ,C_KOLLEGIUMIELLATASOS
    ,C_RENDSZERESGYERMEKVEDELMIKEDV
    ,C_SAJATOSNEVELESU
    ,C_SPORTAG
    ,C_SPORTEDZONEVE
    ,C_SPORTKLUB
    ,C_SZAKKEPESITESSZAMA
    ,C_TANULOIJOGVISZONYOSELTARTOTT
    ,C_TARTOSGYOGYKEZELESSZAMA
    ,C_TOBBGYERMEKIGAZOLASSZAMA
    ,C_VALLASA
    ,C_VESZELYEZTETETT
    ,C_JOGVISZONYVARHATOBEFEJEZESE
    ,C_BEILLESZKEDESIPROBLEMAVALKUZ
    ,C_BESZEDFOGYATEKOSOKMANYSZAM
    ,C_BNOKOD
    ,C_BTMHATAROZATOKMANYSZAM
    ,C_BTMHATAROZATTARTALMA
    ,C_BTMKIALLITOINTEZMENY
    ,C_BTMKONTROLLIDOPONT
    ,C_BTMLETSZAMSULY
    ,C_BTMOKMANYERVENYESSEGKEZDETE
    ,C_BTMOKMANYERVENYESSEGVEGE
    ,C_DISZGRAFIAOKMANYSZAM
    ,C_DISZKALKULIAOKMANYSZAM
    ,C_DISZLEXIAOKMANYSZAM
    ,C_ERTELMIFOGYATEKOS
    ,C_ERTELMIFOGYATEKOSOKMANYSZAM
    ,C_FEJLESZTESREKIJELOLT
    ,C_FEJLESZTOFOGLALKOZAS
    ,C_FEJLESZTOFOGLALKOZASORASZAM
    ,C_HALLASSERULT
    ,C_HALLASSERULTOKMANYSZAM
    ,C_LATASSERULT
    ,C_LATASSERULTOKMANYSZAM
    ,C_MAGATARTASIPROBLEMAVALKUZD
    ,C_MEGISMERONEMORGANIKUSOKMANYS
    ,C_MEGISMEROORGANIKUSOKMANYSZAM
    ,C_MOZGASSERULTOKMANYSZAM
    ,C_SNIKIALLITOINTEZMENY
    ,C_SNIKONTROLLIDOPONT
    ,C_SNILETSZAMSULY
    ,C_SNIMEGHATAROZAS
    ,C_SNIOKMANYERVENYESSEGKEZDETE
    ,C_SNIOKMANYERVENYESSEGVEGE
    ,C_TANULASIPROBLEMADISZGRAFIA
    ,C_TANULASIPROBLEMAVALKUZD
    ,C_TANULASIPROBLEMAVALKUZDDISZK
    ,C_TANULASIPROBLEMAVALKUZDDISZL
    ,C_VISELKEDESNEMORGANIKUSOKMANY
    ,C_VISELKEDESORGANIKUSOKMANYSZA
    ,C_ELSOINTEZMENYOMKOD
    ,C_EVISMETLOTANTARGYAK
    ,C_KOZEPFOKUOKTATASBATIZENHATOD
    ,C_MENEDEKJOGGALRENDELKEZO
    ,C_AGAZAT
    ,C_RESZSZAKKEPESITES
    ,C_SZAKKEPESITES
    ,C_SZAKMACSOPORT
    ,C_EGYEBDONTO
    ,C_MEGALLAPODASOS
    ,C_OSZTV
    ,C_SZETVAGAZAT
    ,C_SZINTVIZSGA
    ,C_SZKTV
    ,C_TECHNIKUSIEVFOLYAM
    ,C_EGYUTTMUKODESES
    ,C_ISKOLAIKERETEKKOZOTT
    ,C_TANULOEVFOLYAMTIPUS
    ,C_FELVETELTANEVEID
    ,C_ALINTEZMENYID
    ,C_ALTANEVID
    ,TOROLT
    ,SERIAL
    ,LASTCHANGED
    ,CREATED
    ,MODIFIER
    ,CREATOR
    ,ELOZOTANEVIREKORDID
    ,ELOZOTANEVIREKORDIDA
    ,C_TORZSLAPSZAM
    ,C_ISSZAKMAIGYAKORLATHIANY
    ,C_ISKIFIRIMPORTALT
    ,C_TANTERVIJELLEMZOID
    ,C_BANKSZAMLATULAJDONOSTIPUSID
    ,C_BANKSZAMLATULAJNEVE
    ,C_KEZIATLAG
    ,C_SZAMITOTTATLAG
    ,C_ISDUALISKEPZESBEN
    ,C_ISMASODIKTOBBSZAKMA
    ,C_JOGVISZONYTIPUSID
    ,C_AGAZATUJSZKTTIPUSID
    ,C_SZAKMATIPUSID
    ,C_SZAKMAIRANYTIPUSID
    ,C_ISERETTSEGIEREDMENYATADHATO
    ,C_AGAZATIALAPVIZSGAEREDMENYE
    ,C_DUALISKEPZOHELYADOSZAMA
    ,C_DUALISKEPZOHELYNEVE
    ,C_ISKULDHETOERETTSEGISZRNEK
    ,C_ISKULDHETOKOZEPFELVETELISZRN
    ,C_ISKULDHETOMERESISZRNEK
    ,C_ISOKLEVELESTECHNIKUSKIMENET
    ,C_ISSZAKKEPZESIMUNKASZERZODESS
    ,C_ISDIAKIGAZOLVANYATADHATOSZRN
    ,C_ISBESZAMITASOS
    ,C_ISOSZTONDIJBOLKIZARVA
    ,C_SZAKIRANYNKTTIPUSID
    ,C_SZAKKEPESITESNKTTIPUSID
    ,C_TANULMANYITERULETNKTTIPUSID
    ,C_ISMULASZTASMIATTKIZART
    ,C_ISSIKERESAGAZATIVIZSGA
    ,C_ISATLAGSZAKKEPZESI
    ,C_ISBESZAMITASOSFIXSZAZALEK
    ,C_MAGANTANULOSAGVEGE
    ,C_AGAZATIALAPVIZSGAEREDMENYESZ
    ,C_OKIRATSZAM
    ,C_TARTOZKODASJOGCIMTIPUSID
    ,C_MUFAJTIPUSID
    ,C_MUVESZETIAGID
    ,C_TANSZAKTIPUSID
    ,C_ISAPACZAIIGENYLO
    ,C_TANTERVID
    ,C_NEMZETKOZIBIZTOSITASIOKMSZAM
    ,C_TARTJOGOKMANYSZAM
    ,C_TARTJOGOKMANYTIPUSID
    ,C_IS9KOZUL8ELOZOTANEVBENVEGEZT
    ,C_ISEXTERNATUSIELLATASBAN
    ,C_ISNAPKOZIOTTHONIELLATASBAN
    ,C_ISAPACZAISZERZODESES
    ,C_ISEGESZNAPOSISKOKTRESZESUL
    ,C_ISKIEMELTENTEHETSEGES
    ,C_ISSZABOKYADOLFSZAKKEPODRESZE
    ,C_ISSZAMITOGEPETOKTCELRAHASZNA
    ,C_ISINGYENESKEPZES
    ,C_ISRENDSZERESGYERMEKVEDELMI
    ,C_ISOTTHONIELLATAS
  ) SELECT
     @newId AS ID -- * int
    ,dk.C_ALLAMIGONDOZOTT AS C_ALLAMIGONDOZOTT -- * char(1)
    ,dk.C_BANKSZAMLASZAM AS C_BANKSZAMLASZAM -- nvarchar(24)
    ,dk.C_BEILLESZKEDESINEHEZSEG AS C_BEILLESZKEDESINEHEZSEG -- * char(1)
    ,dk.C_BEIRASINAPLOSORSZAM AS C_BEIRASINAPLOSORSZAM -- nvarchar(50)
    ,dk.C_BEJARO AS C_BEJARO -- * char(1)
    ,dk.C_DIAKIGAZOLVANYKELTE AS C_DIAKIGAZOLVANYKELTE -- datetime
    ,dk.C_DIAKIGAZOLVANYSZAM AS C_DIAKIGAZOLVANYSZAM -- nvarchar(255)
    ,dk.C_ELOZOINTEZMENY AS C_ELOZOINTEZMENY -- nvarchar(255)
    ,'F' AS C_EVISMETLO -- * char(1)
    ,dk.C_INGYENESTANKONVYELLATASA AS C_INGYENESTANKONVYELLATASA -- int
    ,dk.C_JOGVISZONYATSZUNETELTETO AS C_JOGVISZONYATSZUNETELTETO -- * char(1)
    ,dk.C_MAGANTANULO AS C_MAGANTANULO -- * char(1)
    ,dk.C_MAGANTANULOSAGANAKOKA AS C_MAGANTANULOSAGANAKOKA -- int
    ,dk.C_MAGANTANULOSAGKEZDETE AS C_MAGANTANULOSAGKEZDETE -- datetime
    ,NULL AS C_NAPLOSORSZAM -- int
    ,dk.C_POLGARISZERZODESES AS C_POLGARISZERZODESES -- * char(1)
    ,dk.C_SZAKMAIGYAKORLATON AS C_SZAKMAIGYAKORLATON -- * char(1)
    ,dk.C_SZOCIALISTAMOGATAS AS C_SZOCIALISTAMOGATAS -- * char(1)
    ,dk.C_TANDIJATFIZETO AS C_TANDIJATFIZETO -- * char(1)
    ,dk.C_TANKOTELEZETT AS C_TANKOTELEZETT -- * char(1)
    ,dk.C_TANKOTELEZETTSEGVEGE AS C_TANKOTELEZETTSEGVEGE -- datetime
    ,dk.C_TANULOSZERZODESES AS C_TANULOSZERZODESES -- * char(1)
    ,dk.C_TERITESIDIJATFIZETO AS C_TERITESIDIJATFIZETO -- * char(1)
    ,dk.C_TESTNEVELESTIPUSA AS C_TESTNEVELESTIPUSA -- * int
    ,dk.C_VENDEG AS C_VENDEG -- * char(1)
    ,dk.C_BTMPROBLEMAS AS C_BTMPROBLEMAS -- * char(1)
    ,dk.C_DIAKSPORTKOROS AS C_DIAKSPORTKOROS -- * char(1)
    ,dk.C_EGYHAZKOZOSSEGE AS C_EGYHAZKOZOSSEGE -- nvarchar(255)
    ,dk.C_ETKEZESIKEDVEZMENY AS C_ETKEZESIKEDVEZMENY -- int
    ,dk.C_HALMOZOTTANFOGYATEKOS AS C_HALMOZOTTANFOGYATEKOS -- * char(1)
    ,dk.C_HATRANYOSHELYZETU AS C_HATRANYOSHELYZETU -- * int
    ,dk.C_KOLLEGIUMIELLATASOS AS C_KOLLEGIUMIELLATASOS -- * char(1)
    ,dk.C_RENDSZERESGYERMEKVEDELMIKEDV AS C_RENDSZERESGYERMEKVEDELMIKEDV -- nvarchar(255)
    ,dk.C_SAJATOSNEVELESU AS C_SAJATOSNEVELESU -- * char(1)
    ,dk.C_SPORTAG AS C_SPORTAG -- nvarchar(255)
    ,dk.C_SPORTEDZONEVE AS C_SPORTEDZONEVE -- nvarchar(1000)
    ,dk.C_SPORTKLUB AS C_SPORTKLUB -- nvarchar(100)
    ,dk.C_SZAKKEPESITESSZAMA AS C_SZAKKEPESITESSZAMA -- int
    ,dk.C_TANULOIJOGVISZONYOSELTARTOTT AS C_TANULOIJOGVISZONYOSELTARTOTT -- int
    ,dk.C_TARTOSGYOGYKEZELESSZAMA AS C_TARTOSGYOGYKEZELESSZAMA -- nvarchar(255)
    ,dk.C_TOBBGYERMEKIGAZOLASSZAMA AS C_TOBBGYERMEKIGAZOLASSZAMA -- nvarchar(255)
    ,dk.C_VALLASA AS C_VALLASA -- int
    ,dk.C_VESZELYEZTETETT AS C_VESZELYEZTETETT -- * char(1)
    ,dk.C_JOGVISZONYVARHATOBEFEJEZESE AS C_JOGVISZONYVARHATOBEFEJEZESE -- datetime
    ,dk.C_BEILLESZKEDESIPROBLEMAVALKUZ AS C_BEILLESZKEDESIPROBLEMAVALKUZ -- * char(1)
    ,dk.C_BESZEDFOGYATEKOSOKMANYSZAM AS C_BESZEDFOGYATEKOSOKMANYSZAM -- nvarchar(100)
    ,dk.C_BNOKOD AS C_BNOKOD -- nvarchar(100)
    ,dk.C_BTMHATAROZATOKMANYSZAM AS C_BTMHATAROZATOKMANYSZAM -- nvarchar(255)
    ,dk.C_BTMHATAROZATTARTALMA AS C_BTMHATAROZATTARTALMA -- nvarchar(1000)
    ,dk.C_BTMKIALLITOINTEZMENY AS C_BTMKIALLITOINTEZMENY -- nvarchar(255)
    ,dk.C_BTMKONTROLLIDOPONT AS C_BTMKONTROLLIDOPONT -- datetime
    ,dk.C_BTMLETSZAMSULY AS C_BTMLETSZAMSULY -- * int
    ,dk.C_BTMOKMANYERVENYESSEGKEZDETE AS C_BTMOKMANYERVENYESSEGKEZDETE -- datetime
    ,dk.C_BTMOKMANYERVENYESSEGVEGE AS C_BTMOKMANYERVENYESSEGVEGE -- datetime
    ,dk.C_DISZGRAFIAOKMANYSZAM AS C_DISZGRAFIAOKMANYSZAM -- nvarchar(100)
    ,dk.C_DISZKALKULIAOKMANYSZAM AS C_DISZKALKULIAOKMANYSZAM -- nvarchar(255)
    ,dk.C_DISZLEXIAOKMANYSZAM AS C_DISZLEXIAOKMANYSZAM -- nvarchar(255)
    ,dk.C_ERTELMIFOGYATEKOS AS C_ERTELMIFOGYATEKOS -- int
    ,dk.C_ERTELMIFOGYATEKOSOKMANYSZAM AS C_ERTELMIFOGYATEKOSOKMANYSZAM -- nvarchar(30)
    ,dk.C_FEJLESZTESREKIJELOLT AS C_FEJLESZTESREKIJELOLT -- nvarchar(255)
    ,dk.C_FEJLESZTOFOGLALKOZAS AS C_FEJLESZTOFOGLALKOZAS -- nvarchar(255)
    ,dk.C_FEJLESZTOFOGLALKOZASORASZAM AS C_FEJLESZTOFOGLALKOZASORASZAM -- numeric
    ,dk.C_HALLASSERULT AS C_HALLASSERULT -- int
    ,dk.C_HALLASSERULTOKMANYSZAM AS C_HALLASSERULTOKMANYSZAM -- nvarchar(100)
    ,dk.C_LATASSERULT AS C_LATASSERULT -- int
    ,dk.C_LATASSERULTOKMANYSZAM AS C_LATASSERULTOKMANYSZAM -- nvarchar(100)
    ,dk.C_MAGATARTASIPROBLEMAVALKUZD AS C_MAGATARTASIPROBLEMAVALKUZD -- * char(1)
    ,dk.C_MEGISMERONEMORGANIKUSOKMANYS AS C_MEGISMERONEMORGANIKUSOKMANYS -- nvarchar(100)
    ,dk.C_MEGISMEROORGANIKUSOKMANYSZAM AS C_MEGISMEROORGANIKUSOKMANYSZAM -- nvarchar(100)
    ,dk.C_MOZGASSERULTOKMANYSZAM AS C_MOZGASSERULTOKMANYSZAM -- nvarchar(255)
    ,dk.C_SNIKIALLITOINTEZMENY AS C_SNIKIALLITOINTEZMENY -- nvarchar(255)
    ,dk.C_SNIKONTROLLIDOPONT AS C_SNIKONTROLLIDOPONT -- datetime
    ,dk.C_SNILETSZAMSULY AS C_SNILETSZAMSULY -- * int
    ,dk.C_SNIMEGHATAROZAS AS C_SNIMEGHATAROZAS -- nvarchar(255)
    ,dk.C_SNIOKMANYERVENYESSEGKEZDETE AS C_SNIOKMANYERVENYESSEGKEZDETE -- datetime
    ,dk.C_SNIOKMANYERVENYESSEGVEGE AS C_SNIOKMANYERVENYESSEGVEGE -- datetime
    ,dk.C_TANULASIPROBLEMADISZGRAFIA AS C_TANULASIPROBLEMADISZGRAFIA -- * char(1)
    ,dk.C_TANULASIPROBLEMAVALKUZD AS C_TANULASIPROBLEMAVALKUZD -- * char(1)
    ,dk.C_TANULASIPROBLEMAVALKUZDDISZK AS C_TANULASIPROBLEMAVALKUZDDISZK -- * char(1)
    ,dk.C_TANULASIPROBLEMAVALKUZDDISZL AS C_TANULASIPROBLEMAVALKUZDDISZL -- * char(1)
    ,dk.C_VISELKEDESNEMORGANIKUSOKMANY AS C_VISELKEDESNEMORGANIKUSOKMANY -- nvarchar(100)
    ,dk.C_VISELKEDESORGANIKUSOKMANYSZA AS C_VISELKEDESORGANIKUSOKMANYSZA -- nvarchar(100)
    ,dk.C_ELSOINTEZMENYOMKOD AS C_ELSOINTEZMENYOMKOD -- nvarchar(12)
    ,NULL AS C_EVISMETLOTANTARGYAK -- nvarchar(1000)
    ,dk.C_KOZEPFOKUOKTATASBATIZENHATOD AS C_KOZEPFOKUOKTATASBATIZENHATOD -- * char(1)
    ,dk.C_MENEDEKJOGGALRENDELKEZO AS C_MENEDEKJOGGALRENDELKEZO -- * char(1)
    ,dk.C_AGAZAT AS C_AGAZAT -- int
    ,dk.C_RESZSZAKKEPESITES AS C_RESZSZAKKEPESITES -- int
    ,dk.C_SZAKKEPESITES AS C_SZAKKEPESITES -- int
    ,dk.C_SZAKMACSOPORT AS C_SZAKMACSOPORT -- int
    ,dk.C_EGYEBDONTO AS C_EGYEBDONTO -- * char(1)
    ,dk.C_MEGALLAPODASOS AS C_MEGALLAPODASOS -- * char(1)
    ,dk.C_OSZTV AS C_OSZTV -- * char(1)
    ,dk.C_SZETVAGAZAT AS C_SZETVAGAZAT -- * char(1)
    ,dk.C_SZINTVIZSGA AS C_SZINTVIZSGA -- numeric
    ,dk.C_SZKTV AS C_SZKTV -- * char(1)
    ,dk.C_TECHNIKUSIEVFOLYAM AS C_TECHNIKUSIEVFOLYAM -- * char(1)
    ,dk.C_EGYUTTMUKODESES AS C_EGYUTTMUKODESES -- * char(1)
    ,dk.C_ISKOLAIKERETEKKOZOTT AS C_ISKOLAIKERETEKKOZOTT -- * char(1)
    ,dk.C_TANULOEVFOLYAMTIPUS AS C_TANULOEVFOLYAMTIPUS -- int
    ,dk.C_FELVETELTANEVEID AS C_FELVETELTANEVEID -- * int
    ,dk.C_ALINTEZMENYID AS C_ALINTEZMENYID -- * int
    ,@trgTanevId AS C_ALTANEVID -- * int
    ,dk.TOROLT AS TOROLT -- * char(1)
    ,0 AS SERIAL -- * int
    ,GETDATE() AS LASTCHANGED -- * datetime
    ,GETDATE() AS CREATED -- * datetime
    ,NULL AS MODIFIER -- int
    ,@felhasznaloId AS CREATOR -- int
    ,dk.ID AS ELOZOTANEVIREKORDID -- int
    ,dk.ID AS ELOZOTANEVIREKORDIDA -- int
    ,dk.C_TORZSLAPSZAM AS C_TORZSLAPSZAM -- nvarchar(500)
    ,dk.C_ISSZAKMAIGYAKORLATHIANY AS C_ISSZAKMAIGYAKORLATHIANY -- * char(1)
    ,dk.C_ISKIFIRIMPORTALT AS C_ISKIFIRIMPORTALT -- * char(1)
    ,dk.C_TANTERVIJELLEMZOID AS C_TANTERVIJELLEMZOID -- int
    ,dk.C_BANKSZAMLATULAJDONOSTIPUSID AS C_BANKSZAMLATULAJDONOSTIPUSID -- int
    ,dk.C_BANKSZAMLATULAJNEVE AS C_BANKSZAMLATULAJNEVE -- nvarchar(510)
    ,NULL AS C_KEZIATLAG -- numeric
    ,NULL AS C_SZAMITOTTATLAG -- numeric
    ,dk.C_ISDUALISKEPZESBEN AS C_ISDUALISKEPZESBEN -- * char(1)
    ,dk.C_ISMASODIKTOBBSZAKMA AS C_ISMASODIKTOBBSZAKMA -- * char(1)
    ,dk.C_JOGVISZONYTIPUSID AS C_JOGVISZONYTIPUSID -- int
    ,dk.C_AGAZATUJSZKTTIPUSID AS C_AGAZATUJSZKTTIPUSID -- int
    ,dk.C_SZAKMATIPUSID AS C_SZAKMATIPUSID -- int
    ,dk.C_SZAKMAIRANYTIPUSID AS C_SZAKMAIRANYTIPUSID -- int
    ,dk.C_ISERETTSEGIEREDMENYATADHATO AS C_ISERETTSEGIEREDMENYATADHATO -- * char(1)
    ,dk.C_AGAZATIALAPVIZSGAEREDMENYE AS C_AGAZATIALAPVIZSGAEREDMENYE -- numeric
    ,dk.C_DUALISKEPZOHELYADOSZAMA AS C_DUALISKEPZOHELYADOSZAMA -- nvarchar(20)
    ,dk.C_DUALISKEPZOHELYNEVE AS C_DUALISKEPZOHELYNEVE -- nvarchar(255)
    ,dk.C_ISKULDHETOERETTSEGISZRNEK AS C_ISKULDHETOERETTSEGISZRNEK -- * char(1)
    ,dk.C_ISKULDHETOKOZEPFELVETELISZRN AS C_ISKULDHETOKOZEPFELVETELISZRN -- * char(1)
    ,dk.C_ISKULDHETOMERESISZRNEK AS C_ISKULDHETOMERESISZRNEK -- * char(1)
    ,dk.C_ISOKLEVELESTECHNIKUSKIMENET AS C_ISOKLEVELESTECHNIKUSKIMENET -- * char(1)
    ,dk.C_ISSZAKKEPZESIMUNKASZERZODESS AS C_ISSZAKKEPZESIMUNKASZERZODESS -- * char(1)
    ,dk.C_ISDIAKIGAZOLVANYATADHATOSZRN AS C_ISDIAKIGAZOLVANYATADHATOSZRN -- * char(1)
    ,'F' AS C_ISBESZAMITASOS -- * char(1)
    ,'F' AS C_ISOSZTONDIJBOLKIZARVA -- * char(1)
    ,dk.C_SZAKIRANYNKTTIPUSID AS C_SZAKIRANYNKTTIPUSID -- int
    ,dk.C_SZAKKEPESITESNKTTIPUSID AS C_SZAKKEPESITESNKTTIPUSID -- int
    ,dk.C_TANULMANYITERULETNKTTIPUSID AS C_TANULMANYITERULETNKTTIPUSID -- int
    ,'F' AS C_ISMULASZTASMIATTKIZART -- * char(1)
    ,dk.C_ISSIKERESAGAZATIVIZSGA AS C_ISSIKERESAGAZATIVIZSGA -- * char(1)
    ,'T' AS C_ISATLAGSZAKKEPZESI -- * char(1)
    ,'T' AS C_ISBESZAMITASOSFIXSZAZALEK -- * char(1)
    ,dk.C_MAGANTANULOSAGVEGE AS C_MAGANTANULOSAGVEGE -- datetime
    ,dk.C_AGAZATIALAPVIZSGAEREDMENYESZ AS C_AGAZATIALAPVIZSGAEREDMENYESZ -- int
    ,dk.C_OKIRATSZAM AS C_OKIRATSZAM -- nvarchar(256)
    ,dk.C_TARTOZKODASJOGCIMTIPUSID AS C_TARTOZKODASJOGCIMTIPUSID -- int
    ,dk.C_MUFAJTIPUSID AS C_MUFAJTIPUSID -- int
    ,dk.C_MUVESZETIAGID AS C_MUVESZETIAGID -- int
    ,dk.C_TANSZAKTIPUSID AS C_TANSZAKTIPUSID -- int
    ,dk.C_ISAPACZAIIGENYLO AS C_ISAPACZAIIGENYLO -- int
    ,NULL AS C_TANTERVID
    ,dk.C_NEMZETKOZIBIZTOSITASIOKMSZAM
    ,dk.C_TARTJOGOKMANYSZAM
    ,dk.C_TARTJOGOKMANYTIPUSID
    ,dk.C_IS9KOZUL8ELOZOTANEVBENVEGEZT
    ,dk.C_ISEXTERNATUSIELLATASBAN
    ,dk.C_ISNAPKOZIOTTHONIELLATASBAN
    ,dk.C_ISAPACZAISZERZODESES
    ,dk.C_ISEGESZNAPOSISKOKTRESZESUL
    ,dk.C_ISKIEMELTENTEHETSEGES
    ,dk.C_ISSZABOKYADOLFSZAKKEPODRESZE
    ,dk.C_ISSZAMITOGEPETOKTCELRAHASZNA
    ,dk.C_ISINGYENESKEPZES
    ,dk.C_ISRENDSZERESGYERMEKVEDELMI
    ,dk.C_ISOTTHONIELLATAS
  FROM T_TANULO_OSSZES dk 
  WHERE dk.ID = @tanuloId

  EXEC uspFollowUpFelhasznaloCim
     @intezmenyId = @intezmenyId -- int
    ,@aktTanevId = @srcTanevId -- int
    ,@kovetkezoTanevId = @trgTanevId -- int
    ,@felhasznaloId = @tanuloId -- int

  EXEC uspFollowUpFelhasznaloTelefon
     @intezmenyId = @intezmenyId -- int
    ,@aktTanevId = @srcTanevId -- int
    ,@kovetkezoTanevId = @trgTanevId -- int
    ,@felhasznaloId = @tanuloId -- int

  EXEC uspFollowUpFelhasznaloEmail
     @intezmenyId = @intezmenyId -- int
    ,@aktTanevId = @srcTanevId -- int
    ,@kovetkezoTanevId = @trgTanevId -- int
    ,@felhasznaloId = @tanuloId -- int

  EXEC uspFollowUpTBJogviszony
     @IntezmenyId = @intezmenyId -- int
    ,@AktTanevId = @srcTanevId -- int
    ,@KovetkezoTanevId = @trgTanevId -- int
    ,@FelhasznaloId = @tanuloId -- int  
  
  DECLARE @tanuloSniId int = (SELECT ID FROM T_TANULOSNI t WHERE t.C_TANULOID = @tanuloId)

  IF @tanuloSniId IS NOT NULL BEGIN
    EXEC uspFollowUpTanuloSni
       @intezmenyId = @intezmenyId -- int
      ,@aktTanevId = @srcTanevId -- int
      ,@kovetkezoTanevId = @trgTanevId -- int
      ,@tanuloSniId = @tanuloSniId -- int  
  END  

  DECLARE gvCur CURSOR FOR
    SELECT ID FROM T_GONDVISELO_OSSZES WHERE TOROLT='F' AND C_TANULOID = @tanuloId
  DECLARE @gvId int

  OPEN gvCur
  FETCH NEXT FROM gvCur INTO @gvId
  WHILE @@FETCH_STATUS=0
  BEGIN
    EXEC uspCloneGondviselo
       @gondviseloId = @gvId 
      ,@trgTanevId = @trgTanevId
      ,@intezmenyId = @intezmenyId
      ,@srcTanevId = @srcTanevId
      ,@felhasznaloId = @felhasznaloId
    FETCH NEXT FROM gvCur INTO @gvId
  END
  CLOSE gvCur
  DEALLOCATE gvCur

  DECLARE tmCur CURSOR FOR
    SELECT ID FROM T_TANULOMENTESSEG WHERE TOROLT='F' AND C_TANULOID = @tanuloId
  DECLARE @tmId int

  OPEN tmCur
  FETCH NEXT FROM tmCur INTO @tmId
  WHILE @@FETCH_STATUS=0
  BEGIN
    EXEC uspFollowUpTanuloFelmentes
       @intezmenyId = @intezmenyID
      ,@aktTanevId = @srcTanevId
      ,@kovetkezoTanevId = @trgTanevId
      ,@felmentesId = @tmId 
    FETCH NEXT FROM tmCur INTO @tmId
  END
  CLOSE tmCur
  DEALLOCATE tmCur

  SELECT @newId AS [newId]

END
GO

