﻿-- =============================================
-- Description:  <Minden intézmény aktív tanévéből visszaadja a még ki nem küldött rendszerüzeneteket>
-- =============================================
DROP PROCEDURE IF EXISTS [dbo].[uspGetAllSchemaKikuldendoRendszeruzenet]
GO

CREATE PROCEDURE [dbo].[uspGetAllSchemaKikuldendoRendszeruzenet]
AS
BEGIN
SET NOCOUNT ON;
SELECT 
   x.ID
  ,tte.C_TANULOID TanuloId
  ,f.C_IDPEGYEDIAZONOSITO IdpUniqueId
  ,x.IntezmenyAzonosito
  ,x.UzenetTargy
FROM (
  SELECT TOP(1)
     tes.ID
    ,i.C_AZONOSITO IntezmenyAzonosito
    ,tes.C_TARGY UzenetTargy
  FROM T_TANULOESEMENY tes
    INNER JOIN T_FELHASZNALO fh ON fh.ID = tes.C_FELJEGYZOID AND fh.TOROLT = 'F'
    INNER JOIN T_INTEZMENY i ON i.ID = tes.C_INTEZMENYID
  WHERE fh.C_NYOMTATASINEV = 'Rendszerüzenet'
    AND tes.C_TIPUS = 5482
    AND tes.C_ISERTESITESELKULDVE = 'F'
    AND tes.TOROLT = 'F'
    AND i.TOROLT = 'F'
    AND EXISTS (SELECT 1 FROM T_TANULO_TANULOESEMENY ttes WHERE tes.ID = ttes.C_TANULOESEMENYID)
    AND GETDATE() BETWEEN tes.C_KEZDETE AND tes.C_VEGE
  ) x 
INNER JOIN T_TANULO_TANULOESEMENY tte ON tte.C_TANULOESEMENYID = x.ID
INNER JOIN T_FELHASZNALO f ON f.ID = tte.C_TANULOID

END
GO