DROP PROCEDURE IF EXISTS [uspGetDolgozatReszletek]
GO

CREATE PROCEDURE [uspGetDolgozatReszletek]
   @pOsztalyCsoportId INT
  ,@pTantargyId INT
  ,@pErtekelesTema NVARCHAR(255)
  ,@pDatum DATETIME
AS BEGIN
  SET NOCOUNT ON;
  SELECT
     f.C_NYOMTATASINEV NyomtatasiNev
    ,f.C_SZULETESIDATUM SzuletesiDatum
    ,d.C_VALUE Erdemjegy
    ,te.C_DATUM ErtekelesDatum
    ,te.C_ROGZITESDATUM RogzitesDatum
  FROM T_TANULOERTEKELES_OSSZES te
    INNER JOIN T_FELHASZNALO f ON te.C_TANULOID = f.ID
    INNER JOIN T_OSZTALYZATTIPUS_OSSZES ot ON te.C_ERTEKELESOSZTALYZATID = ot.ID 
      AND te.C_TANEVID = ot.C_ALTANEVID
    INNER JOIN T_DICTIONARYITEMBASE_OSSZES d ON ot.ID = d.ID 
      AND te.C_TANEVID = d.C_TANEVID
  WHERE te.C_OSZTALYCSOPORTID = @pOsztalyCsoportId
    AND te.C_TANTARGYID = @pTantargyId
    AND te.C_ERTEKELESTEMA = @pErtekelesTema
    AND te.C_DATUM = @pDatum
    AND te.C_ISMAGATARTASSZORGALOM = 'F'
    AND te.TOROLT = 'F'
END
GO