﻿DROP PROCEDURE IF EXISTS uspGetDualisTanulok
GO

CREATE PROCEDURE uspGetDualisTanulok
   @pTanevId int
  ,@pLekerdezesDatum datetime
  ,@pSzervezetId int = null
AS BEGIN
  SET NOCOUNT ON;

  SELECT
    t.ID as ID
    ,f.C_NYOMTATASINEV + ' (' + CONVERT(nvarchar(50), f.C_SZULETESIDATUM, 102) + '.) ' as Nev
    ,IIF(C_NEVSORREND = 'T',
      f.C_UTONEV + ' ' + f.C_VEZETEKNEV,
      f.C_VEZETEKNEV + ' ' + f.C_UTONEV) as 'NevElotagNelkul'
    ,f.C_SZULETESIDATUM as SzulDatum
    ,f.C_NEME as Neme
  FROM T_FELHASZNALO_OSSZES f
  INNER JOIN T_TANULO_OSSZES t ON f.ID = t.ID 
    AND t.C_ALTANEVID = f.C_TANEVID 
    AND t.TOROLT = f.TOROLT
  INNER JOIN T_TANULOCSOPORT_OSSZES tcs ON tcs.C_TANULOID = f.ID
    AND (tcs.C_BELEPESDATUM <= @pLekerdezesDatum) 
    AND tcs.C_TANEVID = f.C_TANEVID 
    AND tcs.TOROLT = t.TOROLT
    AND (tcs.C_KILEPESDATUM > @pLekerdezesDatum OR tcs.C_KILEPESDATUM IS NULL)
  INNER JOIN T_OSZTALY_OSSZES o ON o.ID = tcs.C_OSZTALYCSOPORTID 
    AND o.C_ALTANEVID = tcs.C_TANEVID 
    AND o.TOROLT = tcs.TOROLT
  INNER JOIN T_TANULOTANUGYIADATOK tta ON tta.C_TANULOCSOPORTID = tcs.ID 
    AND tta.C_TANEVID = tcs.C_TANEVID 
    AND tta.TOROLT = tcs.TOROLT 
    AND tta.C_SZERVEZETID IS NOT NULL
  WHERE
    f.TOROLT='F' AND f.C_TANEVID = @pTanevId
    AND (@pSzervezetId IS NULL OR @pSzervezetId = tta.C_SZERVEZETID)

END
GO
