DROP PROCEDURE  IF EXISTS uspGetElsoAlairoEugyintezes 
GO

CREATE PROCEDURE uspGetElsoAlairoEugyintezes
   @pVezetoiOraszamokTipusEnumNincs INT
  ,@pVezetoiOraszamokTipusEnumGyakorlatiOktatasvezeto INT
  ,@pTanevId INT
AS
BEGIN
  SET NOCOUNT ON;

  SELECT TOP 1 Alkalmazott.ID AS KretaAzonosito
    ,Felhasznalo.C_NYOMTATASINEV AS Nev
    ,Felhasznalo.C_OKTATASIAZONOSITO AS OktatasiAzonosito
    ,MunkaugyiAdatok.C_VEZETOIORASZAMOK AS Titulus
    ,Felhasznalo.C_EGYEDIAZONOSITO AS EgyediAzonosito
    ,Felhasznalo.C_IDPEGYEDIAZONOSITO AS IdpEgyediAzonosito
  FROM T_ALKALMAZOTT_OSSZES AS Alkalmazott
  INNER JOIN T_FELHASZNALO_OSSZES Felhasznalo ON Alkalmazott.ID = Felhasznalo.ID
    AND Felhasznalo.TOROLT = 'F'
  INNER JOIN T_MUNKAUGYIADATOK_OSSZES MunkaugyiAdatok ON MunkaugyiAdatok.C_ALKALMAZOTTID = Alkalmazott.ID
    AND MunkaugyiAdatok.TOROLT = 'F'
  WHERE Alkalmazott.TOROLT = 'F'
    AND Alkalmazott.C_ALTANEVID = @pTanevId
    AND MunkaugyiAdatok.C_VEZETOIORASZAMOK NOT IN (
       @pVezetoiOraszamokTipusEnumNincs
      ,@pVezetoiOraszamokTipusEnumGyakorlatiOktatasvezeto
      )
  ORDER BY Nev ASC
END
GO


