﻿DROP PROCEDURE IF EXISTS [dbo].[uspGetErettsegiEredmenyekData]
GO

-- =============================================
-- Description:  <Előszedjük a tanulók érettségieredményeinek összefoglaló gridjéhez szükséges adatokat>
-- =============================================
CREATE PROCEDURE [dbo].[uspGetErettsegiEredmenyekData]
   @pOsztalyId INT
AS
BEGIN
  SET NOCOUNT ON;

  SELECT
     Tanulo.ID ID
    ,COUNT(ErettsegiEredmeny.C_TANULOID) MentettErettsegikSzama
    ,Felhasznalo.C_NYOMTATASINEV TanuloNev
    ,Felhasznalo.C_ANYJANEVE AnyjaNeve
    ,Felhasznalo.C_OKTATASIAZONOSITO OMAzonosito
    ,Felhasznalo.C_SZULETESIDATUM SzuletesiIdo
    ,OsztalyCsoport.C_NEV OsztalyNev
    ,OsztalyCsoport.C_VEGZOSEVFOLYAM IsVegzos
  FROM T_TANULO_OSSZES Tanulo
    LEFT JOIN T_TANULOCSOPORT_OSSZES TanuloCsoport ON TanuloCsoport.C_TANULOID = Tanulo.ID AND TanuloCsoport.TOROLT = 'F'
    LEFT JOIN T_OSZTALYCSOPORT_OSSZES OsztalyCsoport ON OsztalyCsoport.ID = TanuloCsoport.C_OSZTALYCSOPORTID AND OsztalyCsoport.TOROLT = 'F'
    LEFT JOIN T_ERETTSEGIEREDMENY_OSSZES ErettsegiEredmeny ON ErettsegiEredmeny.C_TANULOID = Tanulo.ID AND ErettsegiEredmeny.TOROLT = 'F'    
    LEFT JOIN T_FELHASZNALO_OSSZES Felhasznalo ON Felhasznalo.ID = Tanulo.ID AND Felhasznalo.TOROLT = 'F'
  WHERE TanuloCsoport.C_OSZTALYCSOPORTID = @pOsztalyId AND Tanulo.TOROLT = 'F'
  GROUP BY 
     Tanulo.ID
    ,Felhasznalo.C_NYOMTATASINEV
    ,Felhasznalo.C_ANYJANEVE
    ,Felhasznalo.C_OKTATASIAZONOSITO
    ,Felhasznalo.C_SZULETESIDATUM
    ,OsztalyCsoport.C_NEV
    ,OsztalyCsoport.C_VEGZOSEVFOLYAM

END
GO