DROP PROCEDURE  IF EXISTS uspGetIKTAdatok 
GO
  CREATE PROCEDURE uspGetIKTAdatok
     @pIntezmenyId INT
    ,@pTanevId INT
    ,@pEszkozTipusProjektor INT
  AS
  BEGIN
    SET NOCOUNT ON;

    SELECT C_ENAPLOHASZNALATA ENaploHasznalat
      ,C_PROJEKTOROKSZAMA ProjektorokSzama
      ,C_MUKODOPROJEKTOROKSZAMA MukodoProjektorokSzama
      ,(
        SELECT COUNT(1)
        FROM T_ESZKOZ_OSSZES e
        WHERE e.C_INTEZMENYID = intezmeny.C_INTEZMENYID
          AND e.TOROLT = 'F'
          AND e.C_KATEGORIA = @pEszkozTipusProjektor
        ) ProjektorokSzamaGeneralt
      ,(
        SELECT COUNT(1)
        FROM T_ESZKOZ_OSSZES e
        WHERE e.C_INTEZMENYID = intezmeny.C_INTEZMENYID
          AND e.TOROLT = 'F'
          AND e.C_NEMMUKODIK = 'F'
          AND e.C_KATEGORIA = @pEszkozTipusProjektor
        ) MukodoProjektorokSzamaGeneralt
      ,C_WIFIELERES WifiEleres
      ,C_TERMEKSZAMA TermekSzama
      ,C_WIFILEFEDETTTERMEKSZAMA TermekSzamaWifi
      ,(
        SELECT COUNT(1)
        FROM T_TEREM_OSSZES t
        WHERE t.C_INTEZMENYID = intezmeny.C_INTEZMENYID
          AND t.TOROLT = 'F'
        ) TermekSzamaGeneralt
      ,(
        SELECT COUNT(1)
        FROM T_TEREM_OSSZES t
        WHERE t.C_INTEZMENYID = intezmeny.C_INTEZMENYID
          AND t.TOROLT = 'F'
          AND t.C_WIFILEFEDETT = 'T'
        ) TermekSzamaWifiGeneralt
    FROM T_INTEZMENYADATOK_OSSZES intezmeny
      LEFT JOIN T_ADATSZOLGALTATASENAPLO_OSSZES adatszolgEnaplo ON adatszolgEnaplo.C_INTEZMENYID = intezmeny.C_INTEZMENYID
      AND adatszolgEnaplo.C_TANEVID = intezmeny.C_TANEVID
      AND adatszolgEnaplo.TOROLT = 'F'
    WHERE intezmeny.TOROLT = 'F'
      AND intezmeny.C_INTEZMENYID = @pIntezmenyId
      AND intezmeny.C_TANEVID = @pTanevId
  END
GO