DROP PROCEDURE IF EXISTS uspGetOsztalyTanuloinakMunkarendje
GO

CREATE PROCEDURE uspGetOsztalyTanuloinakMunkarendje
   @pOsztalyCsoportId int
  ,@pIsAktivTanev bit
AS BEGIN
  SET NOCOUNT ON;
  DECLARE 
   @munkarenddelNemRendelkezo int
  ,@munkarenddelRendelkezo int

  SET @munkarenddelNemRendelkezo = (SELECT COUNT(tcs.ID) 
  FROM T_TANULOCSOPORT_OSSZES tcs
    INNER JOIN T_TANULOTANUGYIADATOK_OSSZES tta ON tcs.ID = tta.C_TANULOCSOPORTID AND tta.TOROLT = 'F'
  WHERE
    tcs.C_OSZTALYCSOPORTID = @pOsztalyCsoportId
    AND (@pIsAktivTanev = 0 OR tcs.C_BELEPESDATUM <= GETDATE())
    AND tcs.TOROLT = 'F'
    AND (tcs.C_KILEPESDATUM IS NULL OR tcs.C_KILEPESDATUM > GETDATE())
    AND tta.C_TANTERVIJELLEGID IS NULL)

  SET @munkarenddelRendelkezo = (SELECT COUNT(tcs.ID) 
  FROM T_TANULOCSOPORT_OSSZES tcs
    INNER JOIN T_TANULOTANUGYIADATOK_OSSZES tta ON tcs.ID = tta.C_TANULOCSOPORTID AND tta.TOROLT = 'F'
  WHERE
    tcs.C_OSZTALYCSOPORTID = @pOsztalyCsoportId
    AND tcs.TOROLT = 'F'
    AND (@pIsAktivTanev = 0 OR tcs.C_BELEPESDATUM <= GETDATE())
    AND (tcs.C_KILEPESDATUM IS NULL OR tcs.C_KILEPESDATUM > GETDATE())
    AND tta.C_TANTERVIJELLEGID IS NOT NULL)

SELECT
   @munkarenddelNemRendelkezo munkarenddelNemRendelkezo
  ,@munkarenddelRendelkezo munkarenddelRendelkezo

END
GO
