DROP PROCEDURE IF EXISTS [dbo].[uspGetTanarokByOktNevKategoria]
GO

CREATE PROCEDURE [dbo].[uspGetTanarokByOktNevKategoria]
   @pTanevId int
  ,@pOktNevKatTipus int = NULL
  ,@pFelhasznaloId int = NULL
AS
BEGIN
  SET NOCOUNT ON

  DECLARE @sql nvarchar(max)

  SET @sql=CONCAT(N'
  SELECT
     a.ID AS ID
    ,f.C_NYOMTATASINEV AS Nev
    ,ISNULL(f.C_OKTATASIAZONOSITO, ''-'') AS OktatasiAzonosito
    ,dib.C_NAME AS GroupName
    ,f.C_VEZETEKNEV
    ,f.C_UTONEV
  FROM T_ALKALMAZOTT_OSSZES a
    INNER JOIN T_FELHASZNALO_OSSZES f ON f.ID = a.ID
      AND f.TOROLT = ''F''
    INNER JOIN T_MUNKAUGYIADATOK_OSSZES mua ON mua.C_ALKALMAZOTTID = a.ID 
      AND mua.TOROLT = ''F'' 
      AND (mua.C_ALKALMAZASKEZDETE IS NULL or mua.C_ALKALMAZASKEZDETE <= GETDATE())
    INNER JOIN T_FELADATELLATASIHELY_OSSZES feh ON feh.ID = mua.C_FELADATELLATASIHELYID
      AND feh.TOROLT = ''F''
    INNER JOIN T_OKTATASINEVELESIFELADAT_OSSZES onf ON onf.ID = feh.C_OKTATASINEVELESIFELADATTIPUS
      AND onf.TOROLT = ''F''
      AND onf.C_ALTANEVID = feh.C_TANEVID'
    ,IIF(@pOktNevKatTipus IS NOT NULL, N'
      AND onf.C_FELADATKATEGORIAID = @pOktNevKatTipus', '')
    ,N'
    INNER JOIN T_DICTIONARYITEMBASE_OSSZES dib ON dib.ID = onf.C_FELADATKATEGORIAID
      AND dib.C_TANEVID = @pTanevId
      AND dib.TOROLT = ''F''
  WHERE a.TOROLT = ''F''
    AND a.C_ALTANEVID = @pTanevId'
    ,IIF(@pFelhasznaloId IS NOT NULL, N'
    AND a.ID = @pFelhasznaloId', '')
  )

  EXEC sp_executesql @sql
    ,N'@pTanevId int
      ,@pOktNevKatTipus int
      ,@pFelhasznaloId int'
    ,@pTanevId = @pTanevId
    ,@pOktNevKatTipus = @pOktNevKatTipus
    ,@pFelhasznaloId = @pFelhasznaloId

END
GO