﻿DROP PROCEDURE IF EXISTS uspGetTanuloErtekelesei

GO
  CREATE PROCEDURE uspGetTanuloErtekelesei
      @pTanuloId INT
     ,@pTantargyId INT
     ,@pOsztalyCsoportId INT

  AS
  BEGIN
    SET NOCOUNT ON;

  SELECT
     te.ID AS ErtekelesId
    ,t.ID AS TantargyId
    ,t.C_NEV AS TantargyNev
    ,te.C_ERTEKELESOSZTALYZATID AS ErtekelesOsztalyzatId
    ,te.C_ERTEKELESSZOVEG AS ErtekelesSzoveg
    ,te.C_ERTEKELESSZOVEGFORMAZOTT AS ErtekelesSzovegFormazott
    ,te.C_ERTEKELESSZAZALEK AS ErtekelesSzazalek
    ,te.C_ERTEKELESMODID AS ErtekelesModId
    ,te.C_TIPUSID AS ErtekelesTipusId
    ,te.C_ERTEKELESTEMA AS ErtekelesTema
    ,te.C_DATUM AS ErtekelesDatum
    ,em.C_SULY AS ErtekelesSuly
    ,te.C_ROGZITESDATUM AS ErtekelesRogzitesDatum
    ,f.C_IDPEGYEDIAZONOSITO AS TanarUid
    ,ocs.ID AS OsztalyCsoportId
    ,feh.ID AS FeladatEllatasiHelyId
    ,mh.C_NEV MukodesiHelyNev
    ,feh.C_OKTATASINEVELESIFELADATTIPUS AS OktatasiNevelesiFeladatTipusId
  FROM T_TANULOERTEKELES te
    INNER JOIN T_TANTARGY t ON t.ID = te.C_TANTARGYID
    INNER JOIN T_OSZTALYCSOPORT ocs ON ocs.ID = te.C_OSZTALYCSOPORTID
    LEFT JOIN T_ERTEKELESMOD em ON em.ID = te.C_ERTEKELESMODID
    INNER JOIN T_FELADATELLATASIHELY feh ON feh.ID = ocs.C_FELADATELLATASIHELYID
    INNER JOIN T_MUKODESIHELY mh ON mh.C_INTEZMENYID = feh.C_INTEZMENYID AND mh.ID = feh.C_MUKODESIHELYID
    INNER JOIN T_FELHASZNALO f ON f.ID = te.C_ERTEKELOID
  WHERE te.C_TANULOID = @pTanuloId
    AND te.C_TANTARGYID = @pTantargyId
    AND te.C_OSZTALYCSOPORTID = @pOsztalyCsoportId

  END
GO