﻿DROP PROCEDURE IF EXISTS uspSzirStatNemAllami
GO

CREATE PROCEDURE uspSzirStatNemAllami
   @pTanevId int
AS BEGIN
  SELECT
      fh.Id AS ID
    ,C_MUKODESIHELYAZONOSITO AS MukodesiHelyAzonosito
    ,ia.C_NEV AS IntezmenyNeve
    ,mh.C_NEV AS MukodesihelyNeve
    ,mh.C_IRANYITOSZAM + ' ' + mh.C_VAROS  
      + ISNULL( ', ' + mh.C_KOZTERULETNEV + ' ', '') 
      + ISNULL(mh.C_KOZTERULETJELLEGENEV + ' ','') 
      + ISNULL(mh.C_HAZSZAM, '')  
      + ISNULL(', ' + mh.C_EMELET + '. emelet', '') 
      + ISNULL(', ' + mh.C_AJTO + '. ajtó', '') AS MukodesihelyCime
    ,dic.C_NAME AS EllatottFeladat
    ,ISNULL(C_AAOSZLOP + C_ACOSZLOP + C_AHOSZLOP + C_GOSZLOP, 0) AS BevetelOsszesen
    ,ISNULL(C_SOSZLOP + C_UOSZLOP + C_TOSZLOP + C_VOSZLOP + C_WOSZLOP + C_HOSZLOP + C_LOSZLOP + C_POSZLOP + C_ROSZLOP, 0) AS KiadasOsszesen
    ,ISNULL(C_HOSZLOP + C_LOSZLOP + C_POSZLOP + C_ROSZLOP, 0) AS SzemelyiJelleguKifizetesek 
    ,ISNULL(sz.C_AAOSZLOP, 0) AS AAOSZLOP
    ,ISNULL(sz.C_ABOSZLOP, 0) AS ABOSZLOP
    ,ISNULL(sz.C_ACOSZLOP, 0) AS ACOSZLOP
    ,ISNULL(sz.C_ADOSZLOP, 0) AS ADOSZLOP
    ,ISNULL(sz.C_AEOSZLOP, 0) AS AEOSZLOP
    ,ISNULL(sz.C_AFOSZLOP, 0) AS AFOSZLOP
    ,ISNULL(sz.C_AGOSZLOP, 0) AS AGOSZLOP
    ,ISNULL(sz.C_AHOSZLOP, 0) AS AHOSZLOP
    ,ISNULL(sz.C_GOSZLOP, 0) AS GOSZLOP
    ,ISNULL(sz.C_HOSZLOP, 0) AS HOSZLOP
    ,ISNULL(sz.C_IOSZLOP, 0) AS IOSZLOP
    ,ISNULL(sz.C_JOSZLOP, 0) AS JOSZLOP
    ,ISNULL(sz.C_KOSZLOP, 0) AS KOSZLOP
    ,ISNULL(sz.C_LOSZLOP, 0) AS LOSZLOP
    ,ISNULL(sz.C_MOSZLOP, 0) AS MOSZLOP
    ,ISNULL(sz.C_NOSZLOP, 0) AS NOSZLOP
    ,ISNULL(sz.C_OOSZLOP, 0) AS OOSZLOP
    ,ISNULL(sz.C_POSZLOP, 0) AS POSZLOP
    ,ISNULL(sz.C_QOSZLOP, 0) AS QOSZLOP
    ,ISNULL(sz.C_ROSZLOP, 0) AS ROSZLOP
    ,ISNULL(sz.C_SOSZLOP, 0) AS SOSZLOP
    ,ISNULL(sz.C_TOSZLOP, 0) AS TOSZLOP
    ,ISNULL(sz.C_UOSZLOP, 0) AS UOSZLOP
    ,ISNULL(sz.C_VOSZLOP, 0) AS VOSZLOP
    ,ISNULL(sz.C_WOSZLOP, 0) AS WOSZLOP
  FROM T_MUKODESIHELY_OSSZES mh
    INNER JOIN T_FELADATELLATASIHELY_OSSZES fh ON fh.C_MUKODESIHELYID = mh.ID AND fh.TOROLT = 'F'
    INNER JOIN T_INTEZMENYADATOK_OSSZES ia ON ia.C_TANEVID = mh.C_TANEVID AND ia.TOROLT = 'F'
    INNER JOIN T_DICTIONARYITEMBASE_OSSZES dic ON dic.ID = fh.C_OKTATASINEVELESIFELADATTIPUS AND dic.TOROLT = 'F' AND dic.C_TANEVID = mh.C_TANEVID
    LEFT JOIN T_SZIRSTATNEMALLAMIOKTKOLTS_OSSZES sz ON fh.ID = sz.C_FELADATELLATASIHELYID AND sz.TOROLT = 'F'
  WHERE 
    mh.C_TANEVID = @pTanevId
    AND mh.TOROLT = 'F'
END
GO
