﻿DROP PROCEDURE IF EXISTS uspTanmenetImport
GO

CREATE PROCEDURE uspTanmenetImport
   @pIntezmenyId int
  ,@pTanevId int
  ,@pUserId int
  ,@pImportJson nvarchar(max)
  ,@pIsTorles bit
  ,@pTantargyId int
  ,@pOsztalyCsoportId int
AS BEGIN
  SET NOCOUNT ON;

  DECLARE 
    @lastChangedDateTime datetime = GETDATE()

  --Ha törlés van, akkor cask a felhasználóhoz tartozó tanmeneteket törüljük a megadott tantárgy és osztálycsoport alapján!
  IF (@pIsTorles = 1)
  BEGIN
    --Tanmenetek törlése
    UPDATE tm SET
       tm.TOROLT = 'T'
      ,tm.SERIAL = tm.SERIAL + 1
      ,tm.LASTCHANGED = @lastChangedDateTime
      ,tm.MODIFIER = @pUserId
    FROM T_TANMENET_OSSZES tm
    WHERE tm.C_TANTARGYID = @pTantargyId
      AND tm.C_OSZTALYCSOPORTID = @pOsztalyCsoportId
      AND tm.C_FELTOLTOID = @pUserId
      AND tm.C_TANEVID = @pTanevId
      AND tm.TOROLT = 'F'
  END

  --NOTE: A törlés azért false, mert a T_TANMENET_OSSZE view-ból korábban elvégeztük a törlést, mivel egyéb feltélek is kellettek hozzá, ami nem szerepel a uspDynamicImport-ban.
  EXECUTE uspDynamicImport @pIntezmenyId = @pIntezmenyId, @pTanevId = @pTanevId, @pUserId = @pUserId, @pImportJson = @pImportJson, @pIsTorles = 0, @pIsSubTable = 0

END

GO

