-- =============================================
-- Description:  <A tantárgyfelosztás módosításával az órarendi órák>
-- =============================================
DROP PROCEDURE IF EXISTS [dbo].[uspUpdateOrarendiOraAfterTantargyfelosztasUpdate]
GO

CREATE PROCEDURE [dbo].[uspUpdateOrarendiOraAfterTantargyfelosztasUpdate]
   @pIntezmenyId        INT
  ,@pTanevId          INT
  ,@pUserId          INT
  ,@pEredetiTanarId      INT
  ,@pModosultTanarId      INT
  ,@pEredetiTantargyId    INT
  ,@pModosultTantargyId    INT
  ,@pEredetiOsztalyCsoportId  INT
  ,@pModosultOsztalyCsoportId  INT

AS
BEGIN

    BEGIN TRY
    SET NOCOUNT ON
    SET XACT_ABORT ON

    BEGIN TRANSACTION

  UPDATE T_ORARENDIORA_OSSZES SET
     C_TANTARGYID       =  @pModosultTantargyId
    ,C_OSZTALYCSOPORTID   =  @pModosultOsztalyCsoportId
    ,C_TANARID         =  @pModosultTanarId
    ,C_IMPORTALT       =  'F'
    ,SERIAL          +=  1
    ,LASTCHANGED      =   GETDATE()
    ,MODIFIER        =   @pUserId
  FROM
    T_ORARENDIORA_OSSZES
  WHERE
      C_INTEZMENYID     =   @pIntezmenyId
    AND C_TANEVID       =   @pTanevId
    AND C_TANTARGYID     =   @pEredetiTantargyId
    AND C_OSZTALYCSOPORTID  =   @pEredetiOsztalyCsoportId
    AND C_TANARID      =   @pEredetiTanarId
    AND TOROLT        =   'F'

    COMMIT TRANSACTION
       END TRY
       BEGIN CATCH
       IF @@TRANCOUNT > 0 AND XACT_STATE() <> 0 
             ROLLBACK TRAN;
             THROW
       END CATCH
    
END

GO

